#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>
#include <cstrike>
#include <engine>
#include <hamsandwich>
#include <sqlx>
#include <ColorChat>
#include <fun>

#define HUD_DELAY 			2.0
#define MINIMUM_FALL_SPEED 		10
#define MAXIMUM_DAMAGE_FROM_JUMP 	70.0
#define DAMAGE 				60.0
#define DELAY 				0.20
#define ILOSC_SKILLI			23
#define ILOSC_UZYWEK			9
#define ILOSC_POZIOMOW			66
#define	ILOSC_TIMEROW			2
#define	ILOSC_DAMAGE			33
#define MAX_LEN				32
#define MAX_ARGS			4
#define IsPlayer(%1) 			(1 <= %1 <= get_maxplayers())
#define CTRLKEY_1 	IN_USE
#define CTRLKEY_2 	IN_ATTACK2

enum(*= 7){
	TASK_STEALTH,
	TASK_KAMUFLAZ,
	TASK_GUN,
	TASK_ZES,
	TASK_PING,
	TASK_KAR,
	TASK_REMOVED,
	TASK_TRAP
};

enum _:Grenade{
	Flashbang,
	He,
	Smokee,
	C4
}

static const 	gPrefix[] 		= "[4Fragers.com]";
static const 	gThunderSound[] 	= "ambience/thunder_clap.wav";
static const 	gPushSound[] 		= "4Fragers/push.wav";
static const 	gStealthSound[] 	= "4Fragers/stealth.wav";
static const 	gCamouflageSound[] 	= "4Fragers/camouflage.wav";
static const 	gBlindSound[] 		= "scientist/scream21.wav";
static const 	gOddechSound[] 		= "4Fragers/oddech.wav";
static const 	gMoneySound[] 		= "4Fragers/money.wav";
static const 	gAuraModel[] 		= "models/4Fragers/aura.mdl";
static const	gPingwinModelW[]	= "models/4Fragers/w_grenade.mdl";
static const	gPingwinModelP[]	= "models/4Fragers/p_grenade.mdl";
static const	gPingwinModelV[]	= "models/4Fragers/v_grenade.mdl";
static const	gPulapkaModel[]		= "models/4Fragers/pulapka.mdl";
static const	gPulapkaClassname[]	= "xp_pulapka";
static const	gBoomSound[]		= "misc/killChicken.wav";
static const	gBoingSound[]		= "4Fragers/boing.wav";
static const 	gAuraClassname[] 	= "xp_aura";

new		giLastSingle[33];

new 		gXp[33],
		gLevel[33],
		gBonus[33],
		gPoint[33],
		gPlayerMoney[33],
		gSkill[33][ILOSC_SKILLI],
		gUsed[33][ILOSC_UZYWEK],
		gBindKey[33][MAX_ARGS],
		gBindKeyA[33][MAX_ARGS],
		gBindKeyS[33][MAX_ARGS],
		gBindKeyK[33][MAX_ARGS],
		gBindKeyP[33][MAX_ARGS],
		gBindKeyPL[33][MAX_ARGS],
		gBindKeyOS[33][MAX_ARGS],
		gBindKeyOM[33][MAX_ARGS];

new bool:	gHasSuperGrenade[33],
		gCantMove[33],
		gStop[33],
		iSklepikUse[33][7],
		bWeapon[33],
		bUsed[33];

new 		Float:gfDamage[33][ILOSC_DAMAGE],
		Float:gfOrigin[3],
		Float:gfTime[33][ILOSC_TIMEROW],
		Float:gOrigin[3];

new		gStatusMsg,
		gArmorMsg,
		gScreenFadeMsg,
		sprite_lvlup,
		sprite_freez,
		sprite_blood,
		sprite_bloodspray,
		sprite_lightning,
		sprite_smoke,
		sprite_push;

new const gStealth[6]={
	7,
	8,
	9,
	11,
	17,
	0
};	
/*ZAPIS MYSQL*/
new 		Handle:tuple, 
		Handle:db, 
		Handle:query, 
		mkQuery[1024], 
		error[1024], 
		errcode, 
		load_error[33];	
/*TABELA XP*/
new const gTable[ILOSC_POZIOMOW] = {
	250,  // 1
	600,  // 2
	1000, // 3
	1500, // 4
	2000, // 5
	2500, // 6
	3000, // 7
	3500, // 8
	4000, // 9
	5500, // 10
	6000, // 11
	7000, // 12
	8000, // 13
	9000, // 14
	10000, // 15
	11000, // 16
	13000, // 17
	15000, // 18
	17000, // 19
	20000, // 20
	23500, // 21
	26600, // 22
	30000, // 23
	33900, // 24
	37000, // 25
	40100, // 26
	44500, // 27
	48000, // 28
	51999, // 29
	54500, // 30
	59000, // 31
	63000, // 32   
	67500, // 33
	70900, // 34
	75100, // 35
	79999, // 36
	83500, // 37
	87750, // 38
	91000, // 39
	95500, // 40
	99900, // 41
	103500,// 42
	107000,// 43
	110500,// 44
	114900,// 45
	118900,// 46
	121000,// 47
	125500,// 48
	130000,// 49
	140000,// 50
	151000,// 51
	163000,// 52
	175000,// 53
	187000,// 54
	199000,// 55
	212000,// 56
	226000,// 57
	239000,// 58
	252000,// 59
	266000,// 60
	278000,// 61
	313000,// 62
	405000,// 63
	546000,// 64
	750000 // 65
};

enum OBJECTTYPE{
	OBJECT_GENERIC,
	OBJECT_GRENADE,
	OBJECT_PLAYER,
	OBJECT_ARMOURY
};
/*CREATE TABLE IF NOT EXISTS `nazwa_bazy` (
  `id` bigint(20) NOT NULL auto_increment,
  `authid` varchar(24) default NULL,
  `xp` bigint(20) NOT NULL default '0',
  `lvl` int(11) NOT NULL default '0',
  `pkt` int(11) NOT NULL default '0',
  `money` int(11) NOT NULL default '0',
  `gSkill1` int(11) NOT NULL default '0',
  `gSkill2` int(11) NOT NULL default '0',
  `gSkill3` int(11) NOT NULL default '0',
  `gSkill4` int(11) NOT NULL default '0',
  `gSkill5` int(11) NOT NULL default '0',
  `gSkill6` int(11) NOT NULL default '0',
  `gSkill7` int(11) NOT NULL default '0',
  `gSkill8` int(11) NOT NULL default '0',
  `gSkill9` int(11) NOT NULL default '0',
  `gSkill10` int(11) NOT NULL default '0',
  `gSkill11` int(11) NOT NULL default '0',
  `gSkill12` int(11) NOT NULL default '0',
  `gSkill13` int(11) NOT NULL default '0',
  `gSkill14` int(11) NOT NULL default '0',
  `gSkill15` int(11) NOT NULL default '0',
  `gSkill16` int(11) NOT NULL default '0',
  `gSkill17` int(11) NOT NULL default '0',
  `gSkill18` int(11) NOT NULL default '0',
  `gSkill19` int(11) NOT NULL default '0',
  `gSkill20` int(11) NOT NULL default '0',
  `gSkill21` int(11) NOT NULL default '0',
  `gSkill22` int(11) NOT NULL default '0',
  `gSkill23` int(11) NOT NULL default '0',
  `gBindKey` varchar(24) default ' ',
  `gBindKeyA` varchar(24) default ' ',
  `gBindKeyS` varchar(24) default ' ',
  `gBindKeyK` varchar(24) default ' ',
  `gBindKeyP` varchar(24) default ' ',
  `gBindKeyPL` varchar(24) default ' ',
  `gBindKeyOS` varchar(24) default ' ',
  `gBindKeyOM` varchar(24) default ' ',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin2 AUTO_INCREMENT=1 ;*/
new szSklepikMenu[][]={
	"Flesh",
	"Smoke",
	"He",
	"Dodatkowy Exp - (500 XP)",
	"Losowa bron",
	"Naboje",
	"Respawn"
}

new iSklepikKoszt[]={
	5,
	10,
	10,
	100,
	20,
	15,
	25
}

/*WYWOLYWANE NA POCZATKU MAPY*/
public plugin_init() {
	register_plugin("4Fragers EXP MOD", "0.1", "pchela");
	
	gStatusMsg 	= get_user_msgid("StatusText");
	gArmorMsg  	= get_user_msgid("ArmorType");
	gScreenFadeMsg 	= get_user_msgid("ScreenFade");
	
	register_message(23, "blockBoom");
	register_event("Money","blockMoney","b");
	
	register_logevent("Koniec_Rundy", 2, "1=Round_End");
	
	register_forward(FM_EmitSound, "FW_FM_Sound") ;
	register_forward(FM_Touch, "FW_FM_Touch");
	register_forward(FM_PlayerPreThink, "FW_FM_Prethink");
	register_forward(FM_PlayerPreThink,"FW_FM_Prethink2")
	register_forward(FM_PlayerPreThink,"FW_FM_Prethink3")
	register_forward(FM_SetModel,"FW_FM_Setmodel");
	register_think(gAuraClassname, "FW_FM_AuraThink");
	register_event("DeathMsg", "eventDeath", "a");
	register_event("CurWeapon", "eventCurWeapon", "be","1=1");
	register_logevent("eventRoundstart",2,"1=Round_Start");
	RegisterHam(Ham_Touch, "grenade", "eventTouch");
	RegisterHam(Ham_Spawn, 	"player", "eventPlayerSpawn",  1	);
	RegisterHam(Ham_TakeDamage, "player", "eventDamage", 0);
	
	set_task(HUD_DELAY, "writeHud",0, "", 0, "b");
	
	register_clcmd("say /reset", "doReset");
	register_clcmd("say_team /reset", "doReset");
	register_clcmd("say /xp", "openMenu");
	register_clcmd("say_team /xp", "openMenu");
	register_clcmd("say /exp", "openMenu");
	register_clcmd("say_team /exp", "openMenu");
	register_clcmd("say /sklep","menuSklep");
	register_clcmd("say_team /sklep","menuSklep");
	register_clcmd("say /gracze","menuGracze");
	register_clcmd("say_team /gracze","menuGracze");
	
	register_concmd("amx_givemoney", "giveMoney", ADMIN_IMMUNITY, "<nick>");
	register_concmd("amx_zasady", "rules", ADMIN_MENU, "<nick>");
	
	register_clcmd("+skill", "doThunder");
	register_clcmd("+skill2", "doAura");
	register_clcmd("+skill3", "doStealth");
	register_clcmd("+skill4", "doKamuflaz");
	register_clcmd("+skill5", "doPush");
	register_clcmd("+skill6", "doTrap");
	register_clcmd("+skill7", "doBlind");
	register_clcmd("+skill8", "doOddech");
	
	register_clcmd("Zbinduj_Blyskawice_Na", "cmdBind");
	register_clcmd("Zbinduj_Aure_Na", "cmdBindA");
	register_clcmd("Zbinduj_Niewidzialnosc_Na", "cmdBindST");
	register_clcmd("Zbinduj_Kamuflaz_Na", "cmdBindK");
	register_clcmd("Zbinduj_Odepchniecie_Na", "cmdBindP");
	register_clcmd("Zbinduj_Pulapke_Na", "cmdBindPL");
	register_clcmd("Zbinduj_Oslepienie_Na", "cmdBindOS");
	register_clcmd("Zbinduj_Oddech_Na", "cmdBindOM");
	
	register_menucmd(register_menuid("MainMenu"), 1023, "handleMainMenu");
	register_menucmd(register_menuid("SkillMenu"), 1023, "handleSkillMenu");
	register_menucmd(register_menuid("Skill2Menu"), 1023, "handleSkill2Menu");
	register_menucmd(register_menuid("Skill3Menu"), 1023, "handleSkill3Menu");
	register_menucmd(register_menuid("SSMenu"), 1023, "handleSSMenu");
	
	register_menucmd(register_menuid("HPMenu"), 1023, "handleHPMenu"); // 0 Zycie
	register_menucmd(register_menuid("APMenu"), 1023, "handleAPMenu"); // 1 Armor
	register_menucmd(register_menuid("KRMenu"), 1023, "handleKRMenu"); // 2 Ciche kroki
	register_menucmd(register_menuid("RSMenu"), 1023, "handleRSMenu"); // 3 Odrodzenie
	register_menucmd(register_menuid("PRMenu"), 1023, "handlePRMenu"); // 4 Blyskawica
	register_menucmd(register_menuid("ARMenu"), 1023, "handleARMenu"); // 5 Aura zycia
	register_menucmd(register_menuid("STMenu"), 1023, "handleSTMenu"); // 6 Niewidzialnosc
	register_menucmd(register_menuid("KMMenu"), 1023, "handleKMMenu"); // 7 Kamuflaz
	register_menucmd(register_menuid("PSMenu"), 1023, "handlePSMenu"); // 8 Pistolety
	register_menucmd(register_menuid("SGMenu"), 1023, "handleSGMenu"); // 9 Stalowa glowa
	register_menucmd(register_menuid("PHMenu"), 1023, "handlePHMenu"); // 10 Odepchniecie
	register_menucmd(register_menuid("XPMenu"), 1023, "handleXPMenu"); // 11 Dodatkowy exp
	register_menucmd(register_menuid("GRMenu"), 1023, "handleGRMenu"); // 12 Latajacy Pingwin
	register_menucmd(register_menuid("BRMenu"), 1023, "handleBRMenu"); // 13 Lustrzana bariera
	register_menucmd(register_menuid("OBMenu"), 1023, "handleOBMenu"); // 14 Gumowe buty
	register_menucmd(register_menuid("MGMenu"), 1023, "handleMGMenu"); // 15 Karabiny
	register_menucmd(register_menuid("KSMenu"), 1023, "handleKSMenu"); // 16 Dodatkowe obrazenia
	register_menucmd(register_menuid("PLMenu"), 1023, "handlePLMenu"); // 17 Pulapka
	register_menucmd(register_menuid("ZSMenu"), 1023, "handleZSMenu"); // 18 Zestaw broni
	register_menucmd(register_menuid("OSMenu"), 1023, "handleOSMenu"); // 19 Oslepienie
	register_menucmd(register_menuid("WZMenu"), 1023, "handleWZMenu"); // 20 Wzmocnienie
	register_menucmd(register_menuid("SS2Menu"), 1023, "handleSS2Menu"); // 21 Super skok
	register_menucmd(register_menuid("OMMenu"), 1023, "handleOMMenu"); // 22 Oddech Mrozu
	
	register_cvar("expmod_sql_host","85.232.255.138",FCVAR_PROTECTED);
	register_cvar("expmod_sql_user","busydays_eb",FCVAR_PROTECTED);
	register_cvar("expmod_sql_pass","JN93mdfhNm",FCVAR_PROTECTED);
	register_cvar("expmod_sql_db","busydays_eb",FCVAR_PROTECTED);
	register_cvar("expmod_sql_table","expmod",FCVAR_PROTECTED);
	
	set_task(75.0,"bestPlayer");
}

public bestPlayer(){
	new Players[32], playerCount, i, id , lvlstop=0,xpjego=0,www=0;
	new name[32];
	get_players(Players, playerCount, "c");
	for(i=0; i<playerCount; i++){
		id = Players[i];
		if(gXp[id]>lvlstop){
			get_user_name(id,name,31);
			lvlstop=gXp[id];
			xpjego=gLevel[id];
			www=1;
			
		}
		client_cmd(id,"cl_minmodels 0;wait;ex_interp 0.01;wait;hud_centerid 0");
	}
	if(www==1){
		ColorChat(0, GREEN, "^x04%s^x01 Najlepszy gracz z grajacych to ^x04%s ^x03(%i) (%i)" ,gPrefix, name, xpjego, lvlstop);
	}	
	set_task(200.0,"bestPlayer");
}

public Koniec_Rundy()
{
	new exp_to_give;
	for(new i = 1;i<33;i++){
		if(!is_user_alive(i) || get_user_team(i) != 1){
			continue;
		}
		exp_to_give = 5;
		if(get_user_flags(i) & ADMIN_LEVEL_F){
				exp_to_give += 5;
		}
		addExp(i, exp_to_give);
		ColorChat(i, GREEN, "%s^x01 Otrzymales^x03 %d XP^x01 za przezycie rundy!", gPrefix,exp_to_give);
	}
}

public eventDamage(victim, inflicter, attacker, Float:fDamage, bitDamage){
	if(!is_user_alive(victim) || !is_user_connected(victim) || !is_user_connected(attacker))
	return HAM_IGNORED;
	
	if(gSkill[attacker][16]){
		if(get_user_weapon(attacker) == CSW_KNIFE){
			SetHamParamFloat(4, fDamage + float((gSkill[attacker][16] * 2) + gSkill[attacker][19]));
		}
	}
	
	if(gSkill[victim][13]){
		if(IsPlayer(attacker)){
			new random = random_num(1, 100);
			
			if(random <= (gSkill[victim][13] * 3)){
				new szName[32];
				get_user_name(attacker, szName, sizeof szName - 1);
				
				SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)));
				ExecuteHam(Ham_TakeDamage, attacker, "", victim, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)), 1);
				set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 3.0, 3.2, 1.1, 1.1, 1);
				show_hudmessage(victim, "[XP] Lustrzane odbicie: Przyjales mniejsze obrazenia [%.1f zamiast %.1f]^n%s Przyjal [%.1f] obrazen na siebie!", fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)), fDamage, szName, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)));
			}
		}
	}
	
	if(gHasSuperGrenade[attacker]){
		if (bitDamage & (1<<24)){
			if(cs_get_user_team(victim) == CS_TEAM_T){
				new Float:upVector[3];
				upVector[0] = float(read_data(4));
				upVector[1] = float(read_data(5));
				upVector[2] = float(read_data(6));
				
				set_velocity_from_origin(victim, upVector, 1315.0);
			}
			SetHamParamFloat(4, 0.0);
		}
	}
	
	if(gSkill[victim][14]){
		if(bitDamage & DMG_FALL){
			SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill[victim][14]) / 10.0)));
		}
	}
	return HAM_HANDLED;
}

public removeStuck(id){
	id -= TASK_TRAP;
	
	if(!is_user_alive(id)) return 1;
	
	gCantMove[id] = false;
	set_pev(id, pev_maxspeed, 250.0);
	set_pev(id, pev_gravity, 1.0);
	
	set_task(0.2, "eventCurWeapon", id);
	
	return 0;
}

public FW_FM_Sound(entity, channel, const sound[]){
	new owner = pev(entity, pev_owner);
	if(gHasSuperGrenade[owner]){
		if(equal(sound, "weapons/he_bounce-1.wav")){
			emit_sound(entity ,CHAN_ITEM, gBoingSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
			return FMRES_SUPERCEDE;
		}
		if(contain(sound, "weapons/debris") != -1){
			emit_sound(entity ,CHAN_ITEM, gBoomSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}

public eventRoundstart(){
	new ent = -1;
	while((ent = fm_find_ent_by_class(ent, gAuraClassname)))
	{
		engfunc(EngFunc_RemoveEntity, ent);
		
	}
	
	ent = -1;
	while((ent = fm_find_ent_by_class(ent, gPulapkaClassname)))
	{
		engfunc(EngFunc_RemoveEntity, ent);
 
	}
	
	new iPlayers[32], iNum;
	get_players(iPlayers, iNum);
	
	for(new i=0;i<iNum;i++){
		gHasSuperGrenade[iPlayers[i]] = false;
	}
}

public plugin_precache(){
	sprite_blood = 		engfunc(EngFunc_PrecacheModel, "sprites/blood.spr");
	sprite_bloodspray =	engfunc(EngFunc_PrecacheModel, "sprites/bloodspray.spr");
	sprite_lightning = 	engfunc(EngFunc_PrecacheModel, "sprites/lgtning.spr");
	sprite_smoke = 		engfunc(EngFunc_PrecacheModel, "sprites/steam1.spr");
	sprite_push =		engfunc(EngFunc_PrecacheModel, "sprites/shockwave.spr");
	sprite_freez = 		engfunc(EngFunc_PrecacheModel, "sprites/4Fragers/oddech.spr");
	sprite_lvlup = 		engfunc(EngFunc_PrecacheModel, "sprites/4Fragers/lvlup.spr");
	
	engfunc(EngFunc_PrecacheSound, gPushSound);
	engfunc(EngFunc_PrecacheSound, gThunderSound);
	engfunc(EngFunc_PrecacheSound, gBoomSound);
	engfunc(EngFunc_PrecacheSound, gBoingSound);
	engfunc(EngFunc_PrecacheSound, gStealthSound);
	engfunc(EngFunc_PrecacheSound, gCamouflageSound);
	engfunc(EngFunc_PrecacheSound, gBlindSound);
	engfunc(EngFunc_PrecacheSound, gOddechSound);
	engfunc(EngFunc_PrecacheSound, gMoneySound);
	
	engfunc(EngFunc_PrecacheModel, gPingwinModelW);
	engfunc(EngFunc_PrecacheModel, gPingwinModelV);
	engfunc(EngFunc_PrecacheModel, gPingwinModelP);
	engfunc(EngFunc_PrecacheModel, gPulapkaModel);
	engfunc(EngFunc_PrecacheModel, gAuraModel);
}
/*KONIEC WYWOLYWANYCH NA POCZATKU MAPY*/
/*FORWARDY*/
public FW_FM_Touch(toucher, touched, entity, id){
	if(!is_user_alive(toucher) || !is_user_alive(touched)) 
	return;
	
	new touched_origin[3], toucher_origin[3];
	get_user_origin(touched, touched_origin); 
	get_user_origin(toucher, toucher_origin);
	new Float:toucher_minsize[3], Float:touched_minsize[3];
	pev(toucher, pev_mins, toucher_minsize);
	pev(touched, pev_mins, touched_minsize);
	
	if(touched_minsize[2] != -18.0) {
		if(!(toucher_origin[2] == touched_origin[2]+72 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+54 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	else {
		if(!(toucher_origin[2] == touched_origin[2]+68 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+50 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	
	new flags = entity_get_int(touched, EV_INT_flags);
	
	if (flags & FL_ONGROUND){
		if(is_user_alive(touched) && gfDamage[toucher][touched] <= get_gametime()){
			gfDamage[toucher][touched] = get_gametime() + DELAY;
			smashHead(touched, toucher, DAMAGE - float((gSkill[touched][9] * 7)));
		}
	}
}

public FW_FM_Prethink3(id){
	if(!is_user_alive(id) || !gStop[id]){
		return FMRES_IGNORED;
	}
	set_pev(id,pev_velocity,Float:{0.0,0.0,0.0}); // stop motion
	engfunc(EngFunc_SetClientMaxspeed,id,0.00001); // keep immobile
	return FMRES_IGNORED;
}

public FW_FM_Prethink2(id){
	if(!is_user_alive(id)){
		return FMRES_IGNORED;
	}
	static button
	button = pev(id, pev_button);
	new iCtrl1 = !(!(button&CTRLKEY_1));
	new iCtrl2 = !(!(button&CTRLKEY_2));
	
	if(iCtrl1 ^ iCtrl2)
	giLastSingle[id] = 1;
	else if(giLastSingle[id]){
		giLastSingle[id] = 0;
		if(iCtrl1 && iCtrl2 && gSkill[id][21] == 15 && !gUsed[id][7]){
			message_begin(MSG_ONE,get_user_msgid("StatusIcon")  ,{0,0,0},id)  
			write_byte(1)  
			write_string("item_longjump");
			write_byte(255); // red
			write_byte(0); // green
			write_byte(0); // blue
			message_end();
			gUsed[id][7] = true;
			new Float:fl_iNewVelocity[3];
			VelocityByAim(id, 500, fl_iNewVelocity);
			fl_iNewVelocity[2] = 150.0;
			entity_set_vector(id, EV_VEC_velocity, fl_iNewVelocity);
		}
	}
	return FMRES_IGNORED;
}

public FW_FM_Prethink(id){
	static button, oldbutton;
	button =	pev(id, pev_button);
	oldbutton =	pev(id, pev_oldbuttons);
	
	if((button & IN_RELOAD) && !(oldbutton & IN_RELOAD)){
		WyswietlSSMenu(id);
	}
	
	if(!gSkill[id][2]) return 1;
	if(get_user_team(id) != 2) return 1;
	
	set_pev(id, pev_flTimeStepSound, 999);
	return 0;
}
/*KONIEC FORWARDOW*/
/*EVENTY*/
public eventPlayerSpawn(id){
	gUsed[id][0] = false;
	gUsed[id][1] = false;
	gUsed[id][2] = false;
	gUsed[id][3] = false;
	gUsed[id][4] = false;
	gUsed[id][5] = false;
	gUsed[id][6] = false;
	gUsed[id][7] = false;
	gUsed[id][8] = false;
	bWeapon[id] = false;
	bUsed[id] = false;
	
	if(!is_user_alive(id)) return 1;
	
	for(new j = 0;j<7;j++){
		iSklepikUse[id][j] = false;
	}
	set_pev(id, pev_health, float(100 + ((gSkill[id][0] * 10) + gSkill[id][19])));
	fm_add_user_armor(id, float((gSkill[id][1] * 20) + (gSkill[id][19] * 5)), 2);
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 0);
	
	if(task_exists(id + TASK_GUN)) remove_task(id + TASK_GUN);
	if(task_exists(id + TASK_KAR)) remove_task(id + TASK_KAR);
	if(task_exists(id + TASK_ZES)) remove_task(id + TASK_ZES);
	if(task_exists(id + TASK_PING)) remove_task(id + TASK_PING);
	
	if(get_user_team(id) == 2)
		set_task(10.0, "tryPingwin", id + TASK_PING, _, _, "a", 1);
	gCantMove[id] = false;
	set_task(10.1, "tryGun", id + TASK_GUN, _, _, "a", 1);
	set_task(10.2, "tryKar", id + TASK_KAR, _, _, "a", 1);
	set_task(10.3, "tryZes", id + TASK_ZES, _, _, "a", 1);
	set_task(1.0,"tryIcon",id+1111)
	return 0;
}

public tryIcon(id){
	id -= 1111;
	if(gSkill[id][21] == 15 && is_user_alive(id)){
		message_begin(MSG_ONE,get_user_msgid("StatusIcon")  ,{0,0,0},id)  
		write_byte(1)  
		write_string("item_longjump");
		write_byte(0); // red
		write_byte(255); // green
		write_byte(0); // blue
		message_end();
	}
}

public eventDeath(){ 
	new attacker 	= read_data(1); 
	new victim 	= read_data(2);
	
	new bool:bHasAccess = bool:(get_user_flags(attacker) & ADMIN_LEVEL_F);
	new exp_to_give;
	
	if(IsPlayer(attacker)){	
		if(get_user_team(victim) == 2 && get_user_team(attacker) == 1){
			new iCt = 0,iTt=0;
			for(new i = 1;i<33;i++){
				if(!is_user_alive(i) || get_user_team(i) != 2){
					continue;
				}
				iCt++;
			}
			for(new i = 1;i<33;i++){
				if(!is_user_alive(i) || get_user_team(i) != 1){
					continue;
				}
				iTt++;
			}
			if(iCt == 1 && iTt > 1){
				set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 3.0, 3.2, 1.1, 1.1, 3);
				show_hudmessage(0, "UWAGA! Pozostal ostatni CT, schodzimy z kamp"); 
			}
			if(iCt == 1 && iTt == 1){
				set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 3.0, 3.2, 1.1, 1.1, 4);
				show_hudmessage(0, "UWAGA! Jest 1 vs 1, mozna podpowiadac!"); 
			}
		}
		if(get_user_team(attacker) != get_user_team(victim)){
			gBonus[attacker] = 0;
			
			exp_to_give = 10;
			
			if(gLevel[victim] >= (gLevel[attacker] + 25)) 					{ gBonus[attacker] = 25; exp_to_give += 15; }
			if(!gBonus[attacker] && gLevel[victim] >= (gLevel[attacker] + 5)) 		{ gBonus[attacker] = 5;exp_to_give += 10; }
			if(bHasAccess) 									{ exp_to_give += 5; }
			
			if(gSkill[attacker][11] >= 5)
				exp_to_give += (gSkill[attacker][11] / 5);
			
			addExp(attacker, exp_to_give);
			
			ColorChat(attacker, GREEN, "%s^x01 Otrzymales^x03 %d XP^x01 za%s%s%s", gPrefix, exp_to_give, gBonus[attacker] == 0 ? " zabicie" : "", gBonus[attacker] == 5 ? " zabicie gracza minimum 5 poziomow lepszego" : "", gBonus[attacker] == 25 ? " zabicie gracza minimum 25 poziomow lepszego" : "");
			
			gBonus[attacker] = 0;
			
			if(random_num(1,100)<=5){
				changeUserMoney(attacker,5);
				client_cmd(attacker, "spk 4Fragers/money.wav");
			}
		}
	}
	set_task(1.0, "removeEff", victim);
	if(task_exists(victim + TASK_STEALTH)) remove_task(victim + TASK_STEALTH);
	if(task_exists(victim + TASK_GUN)) remove_task(victim + TASK_GUN);
	if(task_exists(victim + TASK_PING)) remove_task(victim + TASK_PING);
	set_task(1.0, "respawn_player", victim);
}

public removeEff(victim) set_pev(victim, pev_effects, EF_NODRAW);

public eventCurWeapon(id){
	if(!is_user_alive(id))
	return 0;
	
	if(gCantMove[id]){
		set_pev(id, pev_maxspeed, 0.1);
		set_pev(id, pev_gravity, 3.0);
	}
	if(get_user_weapon(id) == CSW_HEGRENADE && gHasSuperGrenade[id]){	
		set_pev(id, pev_viewmodel2, gPingwinModelV);
		set_pev(id, pev_weaponmodel2, gPingwinModelP);
		client_cmd(id, "spk 4Fragers/boing.wav");
	}
	
	return 0;
}

public client_connect(id){
	bUsed[id] = false;
	gStop[id] = false;
	bWeapon[id] = false;
	gPlayerMoney[id] = 0;
	LoadData(id);
	gBonus[id] = 0;
	gHasSuperGrenade[id] = false;
	client_cmd(id, "cl_minmodels 0");
}

public client_disconnect(id){
	SaveData(id);
}
/*KONIEC EVENTOW*/
/*MENU*/
public menuGracze(id){
	new pMenu = menu_create("Gracze Online","menuGraczeHandle")
	new szName[64],szTmp[2];
	for(new i = 1;i<33;i++){
		if(!is_user_connected(i)){
			continue;
		}
		get_user_name(i,szName,charsmax(szName));
		num_to_str(i,szTmp,charsmax(szTmp));
		menu_additem(pMenu,szName,szTmp);
	}
	menu_setprop(pMenu,MPROP_EXITNAME,"Wyjscie")
	menu_setprop(pMenu,MPROP_BACKNAME,"Wroc")
	menu_setprop(pMenu,MPROP_NEXTNAME,"Dalej")
	menu_setprop(pMenu,MPROP_NUMBER_COLOR,"\r")
	menu_display(id,pMenu)
	return PLUGIN_HANDLED;
}

public menuGraczeHandle(id,menu,item){
	if(item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	new data[6], iName[64]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)
	new iIdF = str_to_num(data)
	if(is_user_connected(iIdF)){
		static nazwy_skilli[][]={
			"Zycie",
			"Armor",
			"Ciche Kroki",
			"Odrodzenie",
			"Blyskawica",
			"Aura Zycia",
			"Niewidzialnosc",
			"Kamuflaz",
			"Pistolety",
			"Stalowa Glowa",
			"Odepchniecie",
			"Dodatkowy Exp",
			"Latajacy Pingwin",
			"Lustrzana Bariera",
			"Gumowe Buty",
			"Karabiny",
			"Dodatkowe Obrazenia",
			"Pulapka",
			"Zestaw Broni",
			"Wzmocnienie",
			"Oslepienie",
			"Super Skok",
			"Oddech Mrozu"
		}
		new szPathConf[128],szFullDir[164];
		get_configsdir(szPathConf,charsmax(szPathConf));
		formatex(szFullDir,charsmax(szFullDir),"%s/expmod.txt",szPathConf);
		if(file_exists(szFullDir)){
			delete_file(szFullDir);
		}
		write_file(szFullDir,"<body text=^"#FFB000^" bgcolor=^"#000000^"><strong><font size=2><center>",-1)
		new szTmp[128];
		formatex(szTmp,charsmax(szTmp),"Level: %d | Exp: %d", gLevel[iIdF],gXp[iIdF])
		write_file(szFullDir,szTmp,-1);
		formatex(szTmp,charsmax(szTmp),"Kasa: %d$<br>", gPlayerMoney[iIdF])
		write_file(szFullDir,szTmp,-1);
		for(new i = 0;i<ILOSC_SKILLI;i++){
			formatex(szTmp,charsmax(szTmp),"%s: %d<br>", nazwy_skilli[i], gSkill[iIdF][i])
			write_file(szFullDir,szTmp,-1);
		}
		write_file(szFullDir,"</center>",-1)
		show_motd(id,szFullDir,"EXP MOD STATYSTYKI");
	}
	menu_destroy(menu);
	menuGracze(id)
	return PLUGIN_HANDLED;
}

public menuSklep(id){
	new szTmp[64];
	formatex(szTmp,charsmax(szTmp),"%s - Sklepik",gPrefix)
	new pMenu = menu_create(szTmp,"menuSklepHandle")
	for(new i = 0;i<sizeof szSklepikMenu;i++){
		formatex(szTmp,charsmax(szTmp),"%s \r[%d$]",szSklepikMenu[i],iSklepikKoszt[i]);
		menu_additem(pMenu,szTmp);
	}
	menu_setprop(pMenu,MPROP_EXITNAME,"Wyjscie")
	menu_setprop(pMenu,MPROP_NUMBER_COLOR,"\r")
	menu_display(id,pMenu)
	return PLUGIN_HANDLED;
}

public menuSklepHandle(id,menu,item){
	if(item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	if(iSklepikKoszt[item] > gPlayerMoney[id]){
		set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 6.0, 3.0)
		show_hudmessage(id, "[XP] Masz za malo kasy!")
		menu_destroy(menu);
		menuSklep(id)
		return PLUGIN_HANDLED;
	}
	if(iSklepikUse[id][item]){
		set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 6.0, 3.0)
		show_hudmessage(id, "[XP] Juz raz tego uzyles!")
		menu_destroy(menu);
		menuSklep(id)
		return PLUGIN_HANDLED;
	}
	switch(item){
	case 0:{
			fm_give_item(id, "weapon_flashbang");
		}
	case 1:{
			fm_give_item(id, "weapon_smokegrenade");
		}
	case 2:{
			fm_give_item(id, "weapon_hegrenade");
		}
	case 3:{
			gXp[id] += 500;
			refreshExp(id)
		}
	case 4:{
			static iWeapons[]={
				CSW_FAMAS, 
				CSW_AWP, 
				CSW_AUG, 
				CSW_AK47,
				CSW_USP, 
				CSW_DEAGLE, 
				CSW_P228, 
				CSW_FIVESEVEN
			}
			new iRand = iWeapons[random_num(0,sizeof iWeapons - 1)]
			new szWeapName[64];
			get_weaponname(iRand,szWeapName,charsmax(szWeapName))
			fm_give_item(id,szWeapName)
			cs_set_user_bpammo(id, iRand, 0);
			cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), 1);
		}
	case 5:{
			new iWeapons[32], iNum
			get_user_weapons(id,iWeapons,iNum)
			new szWeapName[64];
			for (new i=0; i<iNum; i++){
				if(iWeapons[i] == 2 || iWeapons[i] == 4 || iWeapons[i] == 6 || iWeapons[i] == 9 || iWeapons[i] == 25 || iWeapons[i] == 29 || iWeapons[i] == 31 || iWeapons[i] == 32){
					continue;
				}
				get_weaponname(iWeapons[i],szWeapName,charsmax(szWeapName))
				if(iWeapons[i] == 1 || iWeapons[i] == 11 || iWeapons[i] == 16 || iWeapons[i] == 17 || iWeapons[i] == 26 || iWeapons[i] == 30){
					cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), cs_get_weapon_ammo(find_ent_by_owner(1, szWeapName, id )) + 2);
				}
				else{
					cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), cs_get_weapon_ammo(find_ent_by_owner(1, szWeapName, id )) + 1);
				}
			}
		}
	case 6:{
			if(is_user_alive(id)){
				set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 6.0, 3.0)
				show_hudmessage(id, "[XP] Jestes zywy!")
				menu_destroy(menu);
				menuSklep(id)
				return PLUGIN_HANDLED;
			}
			new iIleZyje = 0;
			for(new i = 1;i<33;i++){
				if(i == id || !is_user_alive(i) || get_user_team(id) != get_user_team(i)){
					continue;
				}
				iIleZyje++;
			}
			if(iIleZyje < 2){
				ColorChat(id, GREEN, "%s^x01 Musi byc^x04 2^x01 zywych graczy z twojego teamu!", gPrefix)
				menu_destroy(menu);
				menuSklep(id)
				return PLUGIN_HANDLED;
			}
			set_bartime(id, 10, 0)
			set_task(10.0,"godmode_off",id+6666);
			set_user_godmode(id,1)
			setGlowShell(id,10.0,255,0,0)
			ExecuteHamB(Ham_CS_RoundRespawn, id)
		}
	}
	changeUserMoney(id,-iSklepikKoszt[item]);
	iSklepikUse[id][item] = true;
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public godmode_off(id){
	id -= 6666;
	if(is_user_connected(id)){
		set_user_godmode(id,0)
		setGlowShell(id,0.0);
	}
}

public WyswietlMainMenu(id) {
	new MenuBody[150], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wMenu umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZresetuj umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wSklepik");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wGracze");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MainMenu");
}

public handleMainMenu(id, key){
	switch(key + 1){
	case 1: WyswietlSkillMenu(id);
	case 2: doReset(id);
	case 3: menuSklep(id);
	case 4: menuGracze(id);
	}
	
	return 1;
}

public WyswietlSSMenu(id) {
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "ExpMod\r -\y Menu Skilli");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y1. %sKamuflaz \y|\w [Uzyty: %s\w]", gSkill[id][7] ? "\w" : "\r", gUsed[id][3] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y2. %sNiewidzialnosc \y|\w [Uzyta: %s\w]", gSkill[id][6] ? "\w" : "\r", gUsed[id][2] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y3. %sOdepchniecie \y|\w [Uzyte: %s\w]", gSkill[id][10] ? "\w" : "\r", gUsed[id][4] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y4. %sPostaw pulapke \y|\w [Postawiona : %s\w]", gSkill[id][17] ? "\w" : "\r", gUsed[id][5] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y5. %sAura zycia \y|\w [Uzyta: %s\w]", gSkill[id][5] ? "\w" : "\r", gUsed[id][1] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y6. %sBlyskawica \y|\w [Uzyta: %s\w]", gSkill[id][4] ? "\w" : "\r", gUsed[id][0] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y7. %sOslepienie \y|\w [Uzyte: %s\w]", gSkill[id][20] ? "\w" : "\r", gUsed[id][6] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y8. %sOddech mrozu \y|\w [Uzyte: %s\w]", gSkill[id][22] ? "\w" : "\r", gUsed[id][8] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\y0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9);
	
	show_menu(id, keys, MenuBody, 5, "SSMenu");
}


public handleSSMenu(id, key){
	switch(key + 1){
	case 1:{
			doKamuflaz(id); 
			WyswietlSSMenu(id);
		}
	case 2:{
			doStealth(id);
			WyswietlSSMenu(id);
		}
	case 3:{
			doPush(id); 
			WyswietlSSMenu(id); 
		}
	case 4:{
			doTrap(id);
			WyswietlSSMenu(id); 
		}
	case 5:{
			doAura(id);
			WyswietlSSMenu(id); 
		}
	case 6:{
			doThunder(id);
			WyswietlSSMenu(id);
		}
	case 7:{
			doBlind(id);
			WyswietlSSMenu(id);
		}
	case 8:{
			doOddech(id);
			WyswietlSSMenu(id);
		}
	}
	return 1;
}

public WyswietlSkill3Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #3");
	
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wPulapka");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wOdepchniecie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wOslepienie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wLatajacy Pingwin \w[\rCT\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wBlyskawica");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wOddech Mrozu");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wAura Zycia");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill3Menu");
}

public handleSkill3Menu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlPLMenu(id);
		}
	case 2:{
			WyswietlPHMenu(id);
		}
	case 3:{
			WyswietlOSMenu(id);
		}
	case 4:{
			WyswietlGRMenu(id);
		}
	case 5:{
			WyswietlPRMenu(id);
		}
	case 6:{
			WyswietlOMMenu(id);
		}
	case 7:{
			WyswietlARMenu(id);
		}
	case 10:{
			WyswietlSkill2Menu(id);
		}
	}
	
	return 1;
}

public WyswietlSkill2Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #2");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wPistolety");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wKarabiny");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wZestaw Broni");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wSuper Skok");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wDodatkowe Obrazenia");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wDodatkowy Exp");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wKamuflaz");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r8. \wNiewidzialnosc");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill2Menu");
}

public handleSkill2Menu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlPSMenu(id);
		}
	case 2:{
			WyswietlMGMenu(id);
		}
	case 3:{
			WyswietlZSMenu(id);
		}
	case 4:{
			WyswietlSS2Menu(id);
		}
	case 5:{
			WyswietlKSMenu(id);
		}
	case 6:{
			WyswietlXPMenu(id);
		}
	case 7:{
			WyswietlKMMenu(id);
		}
	case 8:{
			WyswietlSTMenu(id);
		}
	case 9:{
			WyswietlSkill3Menu(id);
		}
	case 10:{
			WyswietlSkillMenu(id);
		}
	}
	
	return 1;
}

public WyswietlSkillMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #1");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wZycie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wArmor");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wCiche Kroki");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wOdrodzenie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wWzmocnienie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wStalowa Glowa");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wLustrzane Odbicie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r8. \wGumowe Buty");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SkillMenu");
}

public handleSkillMenu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlHPMenu(id);
		}
	case 2:{
			WyswietlAPMenu(id);
		}
	case 3:{
			WyswietlKRMenu(id);
		}
	case 4:{
			WyswietlRSMenu(id);
		}
	case 5:{
			WyswietlWZMenu(id);
		}
	case 6:{
			WyswietlSGMenu(id);
		}
	case 7:{
			WyswietlBRMenu(id);
		}
	case 8:{
			WyswietlOBMenu(id);
		}
	case 9:{
			WyswietlSkill2Menu(id);
		}
	case 10:{
			WyswietlMainMenu(id);
		}
	}
	
	return 1;
}

public WyswietlPLMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz polozyc niewidzialna Pulapke, gdy przeciwnik w nia wejdzie, utknie na 3 sekundy\w^nWymagany poziom:\y 15\w^nWykupione - [%s\w]^nPunkty umiejetnosci: \y%d\r /\y 1\w", gPoint[id], gSkill[id][17] ? "\yTak" : "\rNie", gSkill[id][17]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyPL[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PLMenu");
}

public handlePLMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][17]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][17] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Pulapke^x01 !", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Pulapke_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public pfn_touch(id, ent){
	if(is_user_alive(id)){
		new szClassName[32], vOrigin[3];
		get_user_origin(id, vOrigin);
		
		entity_get_string(ent, EV_SZ_classname, szClassName, 31);
		new owner = pev(ent, pev_owner);
		
		if(equal(szClassName, gPulapkaClassname)){
			if(get_user_team(owner) != get_user_team(id)){
				gCantMove[id] = true;
				set_pev(id, pev_maxspeed, 0.1);
				set_pev(id, pev_gravity, 3.0);
				Smoke(vOrigin, 20, 20);
				
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
				write_byte(TE_IMPLOSION);
				write_coord(vOrigin[0]);
				write_coord(vOrigin[1]);
				write_coord(vOrigin[2]);
				write_byte(80);
				write_byte(10);
				write_byte(10); 
				message_end();
				
				set_task(0.2, "eventCurWeapon", id);
				set_task(3.1, "removeStuck", id + TASK_TRAP, _, _, "a", 1);
				
				set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 1);
				show_hudmessage(id, "^n[XP] Wpadles w Pulapke!");
				engfunc(EngFunc_RemoveEntity, ent);
			}
		}
	}
}

public doTrap(id){
	if(!gSkill[id][17]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][5]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:fOrigin[3], ent;
	entity_get_vector(id, EV_VEC_origin, fOrigin);
	
	ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	set_pev(ent, pev_classname, gPulapkaClassname);
	set_pev(ent, pev_owner, id);
	set_pev(ent, pev_movetype, MOVETYPE_TOSS);
	set_pev(ent, pev_origin, fOrigin);
	set_pev(ent, pev_solid, SOLID_BBOX);
	
	engfunc(EngFunc_SetModel, ent, gPulapkaModel);
	engfunc(EngFunc_SetSize, ent, Float:{-16.0, -16.0, 0.0}, Float:{16.0, 16.0, 2.0});
	
	drop_to_floor(ent);
	
	set_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 64);
	
	client_cmd(id, "spk fvox/blip");
	
	set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 1);
	show_hudmessage(id, "^n[XP] Postawiles pulapke!");
	
	gUsed[id][5] = true;
	
	return 0;
}

public WyswietlKRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Nie slychac twoich krokow\w^nWykupione - [%s\w]^nPunkty umiejetnosci: \y%d\r /\y 1\w", gPoint[id], gSkill[id][2] ? "\yTak" : "\rNie", gSkill[id][2]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KRMenu");
}

public handleKRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][2]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][2] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Ciche Kroki^x01 !", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public doThunder(id){
	if(!gSkill[id][4]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][0]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][0] = true;
		new num;
		new vorigin[3], pos[3];
		get_user_origin(target, vorigin);
		
		vorigin[2] -= 26;
		pos[0] = vorigin[0] + 150;
		pos[1] = vorigin[1] + 150;
		pos[2] = vorigin[2] + 800;
		
		Thunder(pos, vorigin);
		Smoke(vorigin, 10, 10);
		
		switch(gSkill[id][4]){
		case 1: num = (get_user_health(target) / 10)
		case 2: num = (get_user_health(target) / 8)
		case 3: num = (get_user_health(target) / 6)
		case 4: num = (get_user_health(target) / 4)
		case 5: num = (get_user_health(target) / 2)
		}
		
		ExecuteHam(Ham_TakeDamage, target, "", id, float(num), 1);	
	}
	return 0;
}

public doOddech(id){
	if(!gSkill[id][22]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][8]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	gUsed[id][8] = true;
	new iOrigin[3];
	get_user_origin(id, iOrigin, 3);
	
	new Float:fEOrigin[3];
	IVecFVec(iOrigin, fEOrigin);
	
	new Float:fOrigin[3];
	pev(id, pev_origin, fOrigin);
	
	new Float:fDistance;
	xs_vec_sub(fEOrigin, fOrigin, fEOrigin);
	fDistance = vector_length(fEOrigin);
	if(fDistance > 250.0)
	xs_vec_mul_scalar(fEOrigin, 250.0/fDistance, fEOrigin);
	
	new Float:fWysokoscWalca  = vector_length(fEOrigin); 
	
	new args[6];
	args[0] = floatround(fOrigin[0]);
	args[1] = floatround(fOrigin[1]);
	args[2] = floatround(fOrigin[2]);
	args[3] = floatround(fEOrigin[0]);
	args[4] = floatround(fEOrigin[1]);
	args[5] = floatround(fEOrigin[2]);
	
	xs_vec_normalize(fEOrigin, fEOrigin);
	
	burn_damage(id,90.0,fWysokoscWalca,fOrigin);
	set_task(0.1, "task_spray", 0, args, 6, "a", 3);
	emit_sound(id, CHAN_STATIC, gOddechSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
	return 1;
}

#define TASK_STOP 666

burn_damage(id,Float:radius,Float:wys,Float:fOrigin[3]) {	
	new Float:fOrigin2[3],Float:fDistance;
	for(new i=1; i<=33;i++){
		if(!is_user_alive(i) || get_user_team(i) == get_user_team(id)) continue;
		if(i == id) continue;
		
		pev(i, pev_origin, fOrigin2);
		xs_vec_sub(fOrigin2, fOrigin, fOrigin2);
		
		fDistance = vector_length(fOrigin2);
		
		if(floatsqroot(floatpower(wys,2.0) + floatpower(radius,2.0)) >= fDistance){
			gStop[i] = true;
			setGlowShell(i,10.0,0,0,255)
			set_task(float(gSkill[id][22]),"gStopFalse",i+TASK_STOP);
		}
	}
}

setGlowShell(id,Float:width, red=0,green=0,blue=0){
	if(is_user_alive(id)){
		new Float:color[3];
		color[0]=float(red);
		color[1]=float(green);
		color[2]=float(blue);
		set_pev(id,pev_rendermode, kRenderNormal);
		set_pev(id,pev_renderfx,(width)?kRenderFxGlowShell:kRenderFxNone);
		set_pev(id,pev_rendercolor,color);
		set_pev(id,pev_renderamt,width);
	}
}

public gStopFalse(id){
	id -= TASK_STOP;
	setGlowShell(id,0.0);
	gStop[id] = false;
	engfunc(EngFunc_SetClientMaxspeed,id,255.0);
}

public task_spray(args[]) {
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(120) // TE_SPRAY - Throws a shower of sprites or models
	write_coord(args[0]) // start pos
	write_coord(args[1])
	write_coord(args[2])
	write_coord(args[3]) // velocity
	write_coord(args[4])
	write_coord(args[5])
	write_short(sprite_freez) // spr
	write_byte(15) // count
	write_byte(2) // speed
	write_byte(100) //(noise)
	write_byte(5) // (rendermode)
	message_end()
	return PLUGIN_CONTINUE;
}

public doBlind(id){
	if(!gSkill[id][19]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][6]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(gLevel[id] > 25){
		ColorChat(id, GREEN, "%s^x01 Masz za wysoki level, aby tego uzyc!", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][6] = true;
		makeScreenFade(target, float(gSkill[id][19]), float(gSkill[id][19]) + 0.3, 0, 0, 0, 255);
		emit_sound(target, CHAN_STATIC, gBlindSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
		
		set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 1.1, 1.2, 1.5, 1.5, 1);
		show_hudmessage(id, "^n[XP] Oslepiles przeciwnika na %d sekund%s!", gSkill[id][19], gSkill[id][19] == 1 ? "e" : "y");	
	}
	return 0;
}

public WyswietlBRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na bariere ktora odbije %% zadanych Tobie obrazen\w^nWymagany poziom:\y 5\w^nAktualna szansa - [\y%d%%\w]^nAktualnie odbije - [\y%d%%\w]^nSzansa po dodaniu punktu - [\y%d%% Obr\w]^nPo dodaniu punktu odbije - [\y%d%% Obr\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][13] * 3, gSkill[id][13] * 10, (gSkill[id][13] + 1) * 3, (gSkill[id][13] + 1) * 10, gSkill[id][13]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "BRMenu");
}

public handleBRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][13] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(^x045^x01 wymagany)", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][13] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Lustrzana Bariera wynosi teraz^x03 %d %%^x01 i odbija^x03 %d %% obrazen", gPrefix, gSkill[id][13] * 3, gSkill[id][13] * 10);
				WyswietlBRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlOBMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Gumowe Buty redukuja Twoje obrazenia po upadku\w^nAktualnie redukuja - [\y%d%%\w]^nPo dodaniu punktu beda redukowac - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][14] * 5, (gSkill[id][14] + 1) * 5, gSkill[id][14]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OBMenu");
}

public handleOBMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][14] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][14] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Gumowe Buty redukuja teraz^x03 %d %%^x01 obrazen po upadku", gPrefix, gSkill[id][14] * 5);
				WyswietlOBMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlGRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na wylosowanie Pingwina. Nie zadaje obrazen ale odpycha!\w^nWymagany poziom:\y 25\w^nAktualna szansa - [\y%d%%\w]^nSzansa po dodaniu punktu - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][12] * 5, (gSkill[id][12] + 1) * 5, gSkill[id][12]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "GRMenu");
}

public handleGRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][12] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			if(gLevel[id] < 25){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(^x045^x01 wymagany)", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][12] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Latajacego Pingwina wynosi teraz^x03 %d %%", gPrefix, gSkill[id][12] * 5);
				WyswietlGRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlXPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Co 5 dodanych punktow zyskujesz dodatkowy 1XP za zabicie\w^nWymagany poziom:\y 5\w^nAktualnie - [Dodatkow%s\y %dXP\w]^nPo dodaniu 5 punktow - [Dodatkow%s\y %dXP\w]^nPunkty umiejetnosci: \y%d\r /\y 20\w", gPoint[id], gSkill[id][11] >= 5 ? "y" : "e", gSkill[id][11] / 5, gSkill[id][11] >= 5 ? "y" : "e", (gSkill[id][11] + 5) / 5, gSkill[id][11]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "XPMenu");
}

public handleXPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][11] >= 20){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(5 wymagany)", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][11] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Dodatkowy Exp jest teraz na poziomie^x03 %d", gPrefix, gSkill[id][11]);
				WyswietlXPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlKMMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Po uzyciu wygladasz jak przeciwnik\w^nWymagany poziom :\y 2\w^nAktualnie - [Przez\y %d sekund\w]^nPo dodaniu punktu - [Przez\y %d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 4\w", gPoint[id], gSkill[id][7] * 5, (gSkill[id][7] + 1) * 5, gSkill[id][7]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyK[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KMMenu");
}

public handleKMMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][7] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gLevel[id] < 2){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(2 wymagany)", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][7] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Kamuflaz trwa teraz^x03 %d sekund", gPrefix, gSkill[id][7] * 5);
				WyswietlKMMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Kamuflaz_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlSTMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Po uzyciu stajesz sie niewidzialny\w^nWymagany poziom:\y %d\w^nAktualnie - [\y%d sekund\w]^nPo dodaniu punktu - [\y%d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gStealth[gSkill[id][6]], gSkill[id][6] * 2, (gSkill[id][6] + 1) * 2, gSkill[id][6]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyS[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "STMenu");
}

public handleSTMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][6] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gLevel[id] < gStealth[gSkill[id][6]]){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(%d wymagany)", gPrefix, gStealth[gSkill[id][6]]);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][6] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja Niewidzialnosc trwa teraz^x03 %d sekund", gPrefix, gSkill[id][6] * 2);
				WyswietlSTMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Niewidzialnosc_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlRSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na Odrodzenie po smierci\w^nWymagany poziom:\y 5\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill[id][3] * 2, (gSkill[id][3] + 1) * 2, gSkill[id][3]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "RSMenu");
}

public handleRSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][3] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][3] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Odrodzenie wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][3] - 1) * 2, gSkill[id][3] * 2);
				WyswietlRSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlPHMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Gdy uzyjesz tej umiejetnosci przeciwnicy w zasiegu zostana odepchnieci\w^nWymagany poziom:\y 40\w^n", gPoint[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "Aktualny zasieg dzialania - [\y%d untiow\w]^nAktualna sila odepchniecia - [\y%d unitow\w]^nZasieg dzialania po dodaniu punktu - [\y%d untiow\w]^nSila odepchniecia po dodaniu punktu - [\y%d unitow\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", 20 * gSkill[id][10], 40 * gSkill[id][10], 20 * (gSkill[id][10] + 1), 40 * (gSkill[id][10] + 1), gSkill[id][10]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyP[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PHMenu");
}

public handlePHMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][10] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gLevel[id] < 40){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (40 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][10] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz twoje Odepchniecie zadziala z zasiegu^x03 %d unitow^x01 oraz odrzuci z sila^x03 %d unitow", gPrefix, 40 * gSkill[id][10], 20 * gSkill[id][10]);
				WyswietlPHMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Odepchniecie_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlSGMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Redukuje obrazenia gdy ktos stoi Ci na glowie\w^nStandardowo tracisz - [\y%dHP\w]^nAktuaie tracisz - [\y%dHP\w]^nPo dodaniu punktu bedziesz tracic - [\y%dHP\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], floatround(DAMAGE), floatround(DAMAGE - (gSkill[id][9] * 7)), floatround(DAMAGE - ((gSkill[id][9] + 1) * 7)), gSkill[id][9]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SGMenu");
}

public handleSGMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][9] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][9] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz twoja Stalowa Glowa obniza obrazenia o^x03 %dHP", gPrefix, floatround(DAMAGE - ((gSkill[id][9] - 1) * 7)));
				WyswietlSGMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlZSMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie zestawu bronin\w^nWymagany poziom:\y 25\w^nUwaga -\y Aby to wykupic musisz posiadac karabiny na maks. poziomie!\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill[id][18] * 5, (gSkill[id][18] + 1) * 5, gSkill[id][18]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ZSMenu");
}

public handleZSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][15] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Karabiny aby to ulepszyc!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gSkill[id][18] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gLevel[id] < 25){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (25 wymagany)", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][18] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Zestaw wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][18] - 1) * 5, gSkill[id][18] * 5);
				WyswietlZSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlMGMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie losowego karabinu^n\wWymagany poziom:\y 15\w^nUwaga -\y Aby to wykupic musisz posiadac pistolety na maks. poziomie!\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill[id][15] * 5, (gSkill[id][15] + 1) * 5, gSkill[id][15]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MGMenu");
}

public handleMGMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][8] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Pistoletow aby to ulepszyc!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gSkill[id][15] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][15] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Karabin wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][15] - 1) * 5, gSkill[id][15] * 5);
				WyswietlMGMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlOMMenu(id){
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Wypuszczajac chmure mrozu zamraszamy wszystkich, ktorzy w niej sa^n\wWymagany poziom:\y 45^n\wAktualnie zamraza na [\y%d sekund\w]^nPo dodaniu punktu bedzie zamrazac na - [\y%d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][22], gSkill[id][22]+1, gSkill[id][22]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyOM[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OMMenu");
}

public handleOMMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][22] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOMMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOMMenu(id);
				return 1;
			}
			if(gLevel[id] < 45){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (45 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][22] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Oddech Mrozu zostal ulepszony do^x03 %d poziomu zamraza na %d sekund", gPrefix, gSkill[id][22],gSkill[id][22]);
				WyswietlOMMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Oddech_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}


public WyswietlSS2Menu(id){
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Klikajac [e] + [prawy myszy] wybija nas do przodu^n\wWymagany poziom :\y 15^n\wPunkty umiejetnosci: \y%d\r /\y 15\w", gPoint[id], gSkill[id][21]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SS2Menu");
}

public handleSS2Menu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][21] >= 15){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSS2Menu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSS2Menu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][21] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Super Skok zostal wzmociony do^x03 %d poziomu", gPrefix, gSkill[id][21]);
				WyswietlSS2Menu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlWZMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Kazdy punkt dodany w wzmocnienie wzmacnia Twoje inne umiejetnosci\w^nWymagany poziom:\y 3\w^nAktualnie wzmacnia - [\y%d%%\w]^nPo dodaniu punktu bedzie wzmacniac - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][19] * 4, (gSkill[id][19] + 1) * 4, gSkill[id][19]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "WZMenu");
}

public handleWZMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][19] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gLevel[id] < 3){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (3 wymagany)", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][19] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje wzmocnienie zostalo ulepszone na^x03 %d poziom", gPrefix, gSkill[id][19]);
				WyswietlWZMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlOSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz oslepic nakierowanego przeciwnika\w^nDziala do poziomu:\y 25\w^nAktualnie oslepia na - [\y%ds\w]^nPo dodaniu punktu bedzie oslepiac na - [\y%ds\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill[id][20], gSkill[id][20] + 1, gSkill[id][20]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyOS[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OSMenu");
}

public handleOSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][20] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			if(gLevel[id] > 25){
				ColorChat(id, GREEN, "%s^x01 Masz za wysoki poziom, skill mozna posiadac tylko do 25 levela!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][20] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Oslepienie dziala teraz na^x03 %d sekund%s", gPrefix, gSkill[id][20], gSkill[id][20] == 1 ? "e" : "y");
				WyswietlOSMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Oslepienie_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlKSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Twoj noz zadaje dodatkowe obrazenia\w^nWymagany poziom:\y 10\w^nAktualne dodatkowe obrazenia - [\y%d\w]^nDodatkowe obrazenia po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r /\y 10\w", gPoint[id], gSkill[id][16] * 2, (gSkill[id][16] + 1) * 2, gSkill[id][16]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KSMenu");
}

public handleKSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][16] >= 10){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gLevel[id] < 10){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (10 wymagany)", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][16] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Dodatkowe Obrazenia z noza wynosza teraz^x03 %d", gPrefix, gSkill[id][16] * 2);
				WyswietlKSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlPSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie losowego pistoletu\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill[id][8] * 5, (gSkill[id][8] + 1) * 5, gSkill[id][8]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PSMenu");
}

public handlePSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][8] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][8] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Pistolet wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][8] - 1) * 5, gSkill[id][8] * 5);
				WyswietlPSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlARMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz postawic aure zycia ktora bedzie leczyc twoja druzyne\w^nAktualnie - [Leczy\y %dHP\r/\ysek\w przez\y %d sek\w]^nPo dodaniu punktu - [Bedzie leczyc\y %dHP\r/\ysek\w przez\y %d sek\w]^nPunkty umiejetnosci:\y %d\r /\y 4", gPoint[id], gSkill[id][5] * 5, gSkill[id][5] * 5, (gSkill[id][5] + 1) * 5, (gSkill[id][5] + 1) * 5, gSkill[id][5]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKeyA[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ARMenu");
}

public handleARMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][5] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][5] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja aura zycia zostala ulepszona! Trwa teraz^x03 %d sekund^x01 oraz leczy^x03 %d HP^x01 na sekunde", gPrefix, gSkill[id][5] * 5, gSkill[id][5] * 5);
				WyswietlARMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Aure_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlPRMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz zeslac blyskawice na przeciwnika ktory go zrani\w^nWymagany poziom:\y 18\w^nWykupione - [%s\w]^nAktualnie zabiera - [\y%d%% Aktualnego HP\w]^nPo dodaniu zabierze - [\y%d%% Aktualnego HP\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill[id][4] ? "\yTak" : "\rNie", gSkill[id][4] * 10, (gSkill[id][4] + 1) * 10, gSkill[id][4]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod:\w %s]", gBindKey[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PRMenu");
}

public handlePRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][4] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gLevel[id] < 18){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (18 wymagany)", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][4] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje obrazenia Blyskawica wzrosly z^x03 %d%%^x01 do^x03 %d%%^x01 obrazen aktualnego hp", gPrefix, (gSkill[id][4] - 1) * 10, gSkill[id][4] * 10);
				WyswietlPRMenu(id);
				return 1;
			}
		}
	case 2:{
			client_cmd(id, "messagemode Zbinduj_Blyskawice_Na");
			client_cmd(id, "spk fvox/blip");
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlHPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Zwieksza Twoje maksymalne zycie\w^nAktualne zycie - [\y%d\w]^nZycie po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r/\y 5\w", gPoint[id], 100 + (gSkill[id][0] * 10), 100 + (gSkill[id][0] + 1) * 10, gSkill[id][0]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "HPMenu");
}

public handleHPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][0] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][0] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Zycie wzroslo z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill[id][0] - 1, gSkill[id][0]);
				WyswietlHPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlAPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Zwieksza twoj maksymalny pancerz\w^nAktualny pancerz - [\y%d\w]^nPancerz po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r/\y 5\w", gPoint[id], gSkill[id][1] * 20, (gSkill[id][1] + 1) * 20, gSkill[id][1]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "APMenu");
}

public handleAPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill[id][1] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][1] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Armor wzrosl z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill[id][1] - 1, gSkill[id][1]);
				WyswietlAPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}
/*KONIEC MEN*/
/*STOCKI ORAZ ODPOWIEDNIKI DO KOMEND*/
public smashHead(pwned, pwnzor, Float:damage){
	if(get_user_team(pwnzor) != get_user_team(pwned)){
		static Float:fOrigin[3], Float:Health;
		pev(pwned, pev_origin, fOrigin);	
		pev(pwned, pev_health,  Health);
		
		if(Health < damage){
			engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0);
			write_byte(TE_PARTICLEBURST);
			engfunc(EngFunc_WriteCoord, fOrigin[0]);
			engfunc(EngFunc_WriteCoord, fOrigin[1]);
			engfunc(EngFunc_WriteCoord, fOrigin[2]);
			write_short(50);
			write_byte(72);
			write_byte(10);
			message_end();
		}
	
		engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fOrigin, 0);
		write_byte(TE_BLOODSPRITE);
		engfunc(EngFunc_WriteCoord, fOrigin[0] +  8.0);
		engfunc(EngFunc_WriteCoord, fOrigin[1]);
		engfunc(EngFunc_WriteCoord, fOrigin[2] + 26.0);
		write_short(sprite_bloodspray);
		write_short(sprite_blood);
		write_byte(248);
		write_byte(4);
		message_end();
		
		ExecuteHam(Ham_TakeDamage, pwned, "", pwnzor, damage, 1);
	}
}

public writeHud(id){
	for (new id=0; id < 32; id++){
		if(is_user_connected(id) && is_user_alive(id)){
			new szText[150];
			
			if(gLevel[id] >= 65) 	format(szText, sizeof szText - 1,"Poziom: %d/65 | Exp: %d", gLevel[id], gXp[id]);
			else 			format(szText, sizeof szText - 1, "Poziom: %d/65 | Exp: %d/%d (+%i)", gLevel[id], gXp[id], gTable[gLevel[id]], gTable[gLevel[id]]-gXp[id]);
			
			
			message_begin(MSG_ONE, gStatusMsg, {0,0,0}, id);
			write_byte(0);
			write_string(szText);
			message_end();
		}
	}
}

public doReset(id){
	if(is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc nie zywy aby zrestartowac punkty", gPrefix);
		return 1;
	}
	for (new i=0; i < ILOSC_SKILLI; i++){
		gSkill[id][i] = 0;
	}
	gPoint[id] = gLevel[id];
	gPoint[id] += (gLevel[id]/10)
	ColorChat(id, GREEN, "%s^x01 Zresetowales statystyki, posiadasz [%d] wolnych punktow!", gPrefix, gPoint[id]);
	
	return 1;
}

public cmdBind(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKey[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill" , gBindKey[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales blyskawice pod przycisk:^x03 %s", gPrefix, gBindKey[id]);
	
	WyswietlPRMenu(id);
}

public cmdBindA(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyA[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill2" , gBindKeyA[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales aure zycia pod przycisk:^x03 %s", gPrefix, gBindKeyA[id]);
	
	WyswietlARMenu(id);
}

public cmdBindST(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyS[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill3" , gBindKeyS[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales niewidzialnosc pod przycisk:^x03 %s", gPrefix, gBindKeyS[id]);
	
	WyswietlSTMenu(id);
}

public cmdBindK(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyK[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill4" , gBindKeyK[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales kamuflaz pod przycisk:^x03 %s", gPrefix, gBindKeyK[id]);
	
	WyswietlKMMenu(id);
}

public cmdBindP(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyP[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill5" , gBindKeyP[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales odepchniecie pod przycisk:^x03 %s", gPrefix, gBindKeyP[id]);
	
	WyswietlPHMenu(id);
}

public cmdBindPL(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyPL[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill6" , gBindKeyPL[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales pulapke pod przycisk:^x03 %s", gPrefix, gBindKeyPL[id]);
	
	WyswietlPLMenu(id);
}

public cmdBindOS(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyOS[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill7" , gBindKeyOS[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales oslepienie pod przycisk:^x03 %s", gPrefix, gBindKeyOS[id]);
	
	WyswietlOSMenu(id);
}

public cmdBindOM(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyOM[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill8" , gBindKeyOM[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales oddech mrozu pod przycisk:^x03 %s", gPrefix, gBindKeyOM[id]);
	
	WyswietlOMMenu(id);
}

public openMenu(id){
	WyswietlMainMenu(id);
	return 1;
}

public respawn_player(id){
	if(!gSkill[id][3]) return;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][3] * 2){
		set_task(1.0, "respawnPlayer", id);
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Udalo Ci sie odrodzic!", gPrefix);
	}
}

public tryPingwin(id){
	id -= TASK_PING;
	
	if(!gSkill[id][12]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= (gSkill[id][12] * 7)){		
		gHasSuperGrenade[id] = true;
		
		give_item(id, "weapon_hegrenade");
		
		set_task(0.2, "eventCurWeapon", id);
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales^x03 Latajacego Pingwina^x01!", gPrefix);
	}
	
	return 0;
}

public tryKar(id){
	id -= TASK_KAR;
	if(!gSkill[id][15]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][15] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_m4a1");
				cs_set_user_bpammo(id, CSW_M4A1, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_m4a1", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Karabin!", gPrefix);
	}
	return 0;
}

public tryZes(id){
	id -= TASK_KAR;
	if(!gSkill[id][18]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][18] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_deagle");
				fm_give_item(id, "weapon_m4a1");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_user_bpammo(id, CSW_M4A1, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_m4a1", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_usp");
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_p228");
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_elite");
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Zestaw Broni!", gPrefix);
	}
	return 0;
}

public tryGun(id){
	id -= TASK_GUN;
	if(!gSkill[id][8]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][8] * 5){
		new random_weapon = random_num(1, 5);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_deagle");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_glock18");
				cs_set_user_bpammo(id, CSW_GLOCK18, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_glock18", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_p228");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_usp");
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
			}
		case 5:{
				fm_give_item(id, "weapon_elite");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Pistolet%s!", gPrefix, random_weapon == 5 ? "y" : "");
	}
	return 0;
}

public doAura(id){
	if(!gSkill[id][5]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][1]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:mins[3], Float:maxs[3];
	
	mins = Float:{-64.0, -64.0, -64.0};
	maxs = Float:{64.0, 64.0, 64.0};
	
	pev(id, pev_origin, gfOrigin);
	
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target"));
	
	engfunc(EngFunc_SetModel, ent, gAuraModel) ;
	engfunc(EngFunc_SetSize, ent, mins, maxs);
	engfunc(EngFunc_SetOrigin, ent, gfOrigin);
	set_pev(ent, pev_solid, SOLID_TRIGGER);
	set_pev(ent, pev_movetype, MOVETYPE_NONE);
	set_pev(ent, pev_classname, gAuraClassname);
	set_pev(ent, pev_owner, id);
	
	switch(get_user_team(id)){
	case 1: set_rendering(ent, kRenderFxGlowShell, 255, 0, 0, kRenderTransAlpha, 35);
	case 2: set_rendering(ent, kRenderFxGlowShell, 0, 32, 255, kRenderTransAlpha, 35);
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	set_task(float(gSkill[id][5]*5), "taskAuraRemove", ent);
	
	ColorChat(id, GREEN, "%s^x01 Postawiles Aure^x03 [%dHP / sekunde^x01 stac bedzie:^x03 %d sekund]", gPrefix, gSkill[id][5] * 5, gSkill[id][5] * 5);
	gUsed[id][1] = true;
	return 0;
} 

fm_cs_get_grenade_type_myid(index){
	if(get_pdata_int(index, 96) & (1<<8)){
		return 3;
	}	
	
	return get_pdata_int(index, 114) & 3;
}

public taskAuraRemove(ent){
	if(pev_valid(ent)){
		engfunc(EngFunc_RemoveEntity, ent);
	}
}

public FW_FM_AuraThink(ent)
{
	if(!pev_valid(ent))
	return 0;
	
	static iPlayers[32], iNum;
	get_players(iPlayers, iNum, "a");
	static i;
	new owner = pev(ent, pev_owner);
	
	for(i = 0 ; i < iNum; i++)
	{
		new Float: Health
		pev(iPlayers[i], pev_health, Health);
		if(entity_range(iPlayers[i], ent) <= 100.0 && get_user_team(owner) == get_user_team(iPlayers[i])){
			if(Health >= (100 + (gSkill[iPlayers[i]][0] * 10)))
			continue;
			else{
				set_pev(iPlayers[i], pev_health, (Health + gSkill[owner][5] * 5.0) >= float((100 + (gSkill[iPlayers[i]][0] * 10))) ? float((100 + (gSkill[iPlayers[i]][0] * 10))): (Health + gSkill[owner][5] * 5.0));
				message_begin(MSG_ONE, gScreenFadeMsg, {0,0,0}, iPlayers[i]);
				write_short((1<<12));
				write_short((1<<8));
				write_short(0x0000);
				write_byte(255);
				write_byte(0);
				write_byte(64);
				write_byte(64);
				message_end();
			}
		}
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	return 0;
}

public doStealth(id){
	if(!gSkill[id][6]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][2]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	if(bUsed[id]){
		ColorChat(id, GREEN, "%s^x01 Nie mozesz teraz tego uzyc", gPrefix);
		return 1;
	}
	
	bUsed[id] = true;
	
	if(task_exists(id + TASK_STEALTH)) remove_task(id + TASK_STEALTH);
	
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 0);
	
	gfTime[id][0] = float((2 * gSkill[id][6]));
	set_task(0.1, "Stealth_Countdown", id + TASK_STEALTH, "", _, "a", (gSkill[id][6] * 2) * 10);
	
	emit_sound(id, CHAN_STATIC, gStealthSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
	set_bartime(id,floatround(gfTime[id][0]),0);
	gUsed[id][2] = true;
	
	return 0;
}

public Stealth_Countdown(id){
	id -= TASK_STEALTH;
	
	if(gfTime[id][0] <= 0.3){
		set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 255);
		bUsed[id] = false;
	}
	
	gfTime[id][0] -= 0.1;
}

public doKamuflaz(id){
	if(!gSkill[id][7]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][3]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	if(bUsed[id]){
		ColorChat(id, GREEN, "%s^x01 Nie mozesz teraz tego uzyc", gPrefix);
		return 1;
	}
	
	bUsed[id] = true;
	gfTime[id][1] = float(((5 * gSkill[id][7]) + gSkill[id][19]));
	set_task(0.1, "Kamuflaz_Countdown", id + TASK_KAMUFLAZ, "", _, "a", ((gSkill[id][7] * 5) + gSkill[id][19]) * 10);
	
	switch(get_user_team(id)){
		case 1:	cs_set_user_model(id, "urban");
		case 2:	cs_set_user_model(id, "leet");
	}
	
	emit_sound(id, CHAN_STATIC, gCamouflageSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
	set_bartime(id,floatround(gfTime[id][1]),0);
	gUsed[id][3] = true;
	
	return 1;
}

public Kamuflaz_Countdown(id){
	id -= TASK_KAMUFLAZ;
	
	if(gfTime[id][1] <= 0.3){
		bUsed[id] = false;
		cs_reset_user_model(id);
	}
	
	gfTime[id][1] -= 0.1;
}

fm_add_user_armor(id, Float:amount, type){
	set_pev(id, pev_armorvalue, amount);
	set_pdata_int(id, 112, type);
	
	if (type){
		message_begin(MSG_ONE_UNRELIABLE , gArmorMsg , _ , id);
		write_byte(type == 2 ? 1 : 0);
		message_end();
	}
} 

public respawnPlayer(id){
	ExecuteHamB(Ham_CS_RoundRespawn, id);
	
	if (is_user_bot(id) && pev(id, pev_deadflag) == DEAD_RESPAWNABLE){
		dllfunc(DLLFunc_Spawn, id);
	}
	
	new name[32];
	get_user_name(id,name,31);
	
	set_hudmessage(127, 255, 85, -1.0, 0.15, 1, 0.0, 5.0, 0.1, 0.2, 4);
	show_hudmessage(0, "Gracz ^"%s^" odrodzil sie!", name);
}

Thunder(start[3], end[3]){			
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ); 
	write_byte(TE_BEAMPOINTS); 
	write_coord(start[0]); 
	write_coord(start[1]); 
	write_coord(start[2]); 
	write_coord(end[0]); 
	write_coord(end[1]); 
	write_coord(end[2]); 
	write_short(sprite_lightning); 
	write_byte(1);
	write_byte(5);
	write_byte(7);
	write_byte(20);
	write_byte(30);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	message_end();
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, end);
	write_byte(TE_SPARKS);
	write_coord(end[0]);
	write_coord(end[1]);
	write_coord(end[2]);
	message_end();
	
	emit_sound(0 ,CHAN_ITEM, gThunderSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
}

makeScreenFade(id, Float:fDuration, Float:fHoldtime, red, green, blue, alpha)
{
	message_begin(MSG_ONE, gScreenFadeMsg, {0, 0, 0}, id);
	write_short(floatround(4096.0 * fDuration, floatround_round));
	write_short(floatround(4096.0 * fHoldtime, floatround_round));
	write_short(4096);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(alpha);
	message_end();

	return 1;
}

Smoke(iorigin[3], scale, framerate){
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_SMOKE);
	write_coord(iorigin[0]);
	write_coord(iorigin[1]);
	write_coord(iorigin[2]);
	write_short(sprite_smoke);
	write_byte(scale);
	write_byte(framerate);
	message_end();
}

stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] ){
	new Float:fEntOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, fEntOrigin);

	new Float:fDistance[3];
	fDistance[0] = fEntOrigin[0] - fOrigin[0];
	fDistance[1] = fEntOrigin[1] - fOrigin[1];
	fDistance[2] = fEntOrigin[2] - fOrigin[2];

	new Float:fTime = ( vector_distance( fEntOrigin,fOrigin) / fSpeed);

	fVelocity[0] = fDistance[0] / fTime;
	fVelocity[1] = fDistance[1] / fTime;
	fVelocity[2] = fDistance[2] / fTime;

	return (fVelocity[0] && fVelocity[1] && fVelocity[2]);
}

stock set_velocity_from_origin(ent, Float:fOrigin[3], Float:fSpeed){
	new Float:fVelocity[3];
	get_velocity_from_origin(ent, fOrigin, fSpeed, fVelocity);

	entity_set_vector(ent, EV_VEC_velocity, fVelocity);

	return (1);
}

public doPush(id){
	if(!gSkill[id][10]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][4]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	if(get_user_team(id) == 2){
		ColorChat(id, GREEN, "%s^x01 Tylko^x04 TT^x01 moze uzycwac tego skilla!", gPrefix);
		return 1;
	}

	static iPlayers[32], iNum, i;
	get_players(iPlayers, iNum, "a");

	for(i = 0 ; i < iNum; i++)
	{	
		new vOrigin2[3];
		get_user_origin(id, vOrigin2);

		message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
		write_byte(21);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2]);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2] + (gSkill[id][10] * 50));
		write_short(sprite_push);
		write_byte(0);
		write_byte(0);
		write_byte(5);
		write_byte(64);
		write_byte(0);
		write_byte(128);
		write_byte(128);
		write_byte(135);
		write_byte(128);
		write_byte(0);
		message_end();
		
		emit_sound(id ,CHAN_ITEM, gPushSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
		
		if(entity_range(iPlayers[i], id) <= float(gSkill[id][10] * 40) && get_user_team(id) != get_user_team(iPlayers[i])){
			new Float:fOrigin[2][3], vOrigin[3], b, flags;
			entity_get_vector(iPlayers[i], EV_VEC_origin, fOrigin[1]);
			entity_get_vector(id, EV_VEC_origin, fOrigin[0]);
			get_user_origin(iPlayers[i], vOrigin);
			flags = entity_get_int(iPlayers[i], EV_INT_flags);
			
			for (b = 0;b <= 2 ; b ++) 
			{
				fOrigin[1][b] -= fOrigin[0][b];
				
				if (flags & FL_ONGROUND)
				fOrigin[1][b] *= (float(gSkill[id][10]) * 4.0);
				
				else
				fOrigin[1][b] *= (float(gSkill[id][10]) * 1.5);
			}
			
			engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0);
			write_byte(TE_PARTICLEBURST);
			engfunc(EngFunc_WriteCoord, fOrigin[0][0]);
			engfunc(EngFunc_WriteCoord, fOrigin[0][1]);
			engfunc(EngFunc_WriteCoord, fOrigin[0][2]);
			write_short(50);
			write_byte(235);
			write_byte(10);
			message_end();
			
			entity_set_vector(iPlayers[i], EV_VEC_velocity, fOrigin[1]);
		}
	}
	gUsed[id][4] = true;
	
	return 0;
}

public SaveData(id)
{
	if ( load_error[ id ] )
	{
		new nickname[35];
		get_user_name(id, nickname, 34);
		log_amx("There was an error on loading so stats won't be saved for: %s", nickname);
		return 0;
	}
	new host[32], user[32], pass[32], dbname[32], table[32];
	get_cvar_string("expmod_sql_host", host, 31);
	get_cvar_string("expmod_sql_user", user, 31);
	get_cvar_string("expmod_sql_pass", pass, 31);
	get_cvar_string("expmod_sql_db", dbname, 31);
	get_cvar_string("expmod_sql_table", table, 31);

	tuple = SQL_MakeDbTuple(host, user, pass, dbname);
	
	if ( tuple ) db = SQL_Connect(tuple, errcode, error, 1023);

	if (db == Empty_Handle)
	{
		log_amx("Could not connect to database. Error #%i: %s", errcode, error);
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		return 0;
	}
	else
	{
		new authid[35];
		new where_statement[1024];
		get_user_authid(id, authid, 34);
		format(where_statement, 199, "`authid` = '%s'", authid);
		new iLen = 0;
		iLen += format(mkQuery[iLen], 1023-iLen, "UPDATE %s SET \
								xp = '%d', \
								lvl = '%d', \
								pkt = '%d', \
								money = '%d' \
								"
										,table, gXp[id], gLevel[id], gPoint[id], gPlayerMoney[id])
		for(new i = 0;i<ILOSC_SKILLI;i++){
			iLen += format(mkQuery[iLen], 1023-iLen,", gSkill%d = '%d' ",i+1,gSkill[id][i]);
		}
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKey = '%s'",gBindKey[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyA = '%s'",gBindKeyA[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyS = '%s'",gBindKeyS[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyK = '%s'",gBindKeyK[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyP = '%s'",gBindKeyP[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyPL = '%s'",gBindKeyPL[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyOS = '%s'",gBindKeyOS[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,",gBindKeyOM = '%s' ",gBindKeyOM[id]);
		iLen += format(mkQuery[iLen], 1023-iLen,"WHERE %s",where_statement);
		query = SQL_PrepareQuery(db, mkQuery);
		SQL_Execute(query);

		SQL_QueryError(query, error, 1023);
		if(error[0])
		{
			log_amx("Could not execute query ^"%s^" -- Error: %s",mkQuery,error);
			if ( db ) SQL_FreeHandle( db );
			if ( tuple ) SQL_FreeHandle( tuple );
			if ( query ) SQL_FreeHandle( query );
			return 0;
		}
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		if ( query ) SQL_FreeHandle( query );
	}
	return 0;
}

public LoadData(id)
{
	new host[32], user[32], pass[32], dbname[32], table[32];
	get_cvar_string("expmod_sql_host", host, 31);
	get_cvar_string("expmod_sql_user", user, 31);
	get_cvar_string("expmod_sql_pass", pass, 31);
	get_cvar_string("expmod_sql_db", dbname, 31);
	get_cvar_string("expmod_sql_table", table, 31);

	tuple = SQL_MakeDbTuple(host, user, pass, dbname);
	
	if(tuple) db = SQL_Connect(tuple, errcode, error, 1023);

	if (db == Empty_Handle)
	{
		new nickname[35];
		get_user_name(id, nickname, 34);
		
		log_amx( "Could not connect to database. Error #%i: %s", errcode, error );
		log_amx( "SCXPM: Loading player stats failed. failed load protection initialated for: %s", nickname);
		log_amx( "SCXPM: Start from level 0" );
		load_error[ id ] = true ;
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		return 0;
	}
	else
	{
		new where_statement[1024];
		new authid[35];
		
		get_user_authid(id, authid, 34);
		
		format(where_statement, 199, "`authid` = '%s'", authid);
		format(mkQuery, 1023, "SELECT `xp`,`lvl`,`pkt`,`money`,`gSkill1`,`gSkill2`,`gSkill3`,`gSkill4`,`gSkill5`,`gSkill6`,`gSkill7`,`gSkill8`,`gSkill9`,`gSkill10`,`gSkill11`,`gSkill12`,`gSkill13`,`gSkill14`,`gSkill15`,`gSkill16`,`gSkill17`,`gSkill18`,`gSkill19`,`gSkill20`,`gSkill21`,`gSkill22`,`gSkill23`,`gBindKey`,`gBindKeyA`,`gBindKeyS`,`gBindKeyK`,`gBindKeyP`,`gBindKeyPL`,`gBindKeyOS`,`gBindKeyOM` FROM `%s` WHERE %s", table, where_statement);
		query = SQL_PrepareQuery(db, mkQuery);
		SQL_Execute(query);

		SQL_QueryError(query,error,1023);
		if(error[0])
		{
			log_amx( "Could not execute query ^"%s^" -- Error: %s", mkQuery, error );
			load_error[ id ] = true;
			if ( db ) SQL_FreeHandle( db );
			if ( tuple ) SQL_FreeHandle( tuple );
			if ( query ) SQL_FreeHandle( query );
			return 0;
		}
		else
		{
			if (SQL_NumResults ( query ) == 1)
			{
				gXp[id] = SQL_ReadResult(query, 0);
				gLevel[id] = SQL_ReadResult(query, 1);
				gPoint[id] = SQL_ReadResult(query, 2); 
				gPlayerMoney[id] = SQL_ReadResult(query, 3); 
				for(new i = 4;i<ILOSC_SKILLI+4;i++){
					 gSkill[id][i-4] = SQL_ReadResult(query,i); 
				}
				SQL_ReadResult(query,27,gBindKey,MAX_ARGS-1); 
				SQL_ReadResult(query,28,gBindKeyA,MAX_ARGS-1); 
				SQL_ReadResult(query,29,gBindKeyS,MAX_ARGS-1); 
				SQL_ReadResult(query,30,gBindKeyK,MAX_ARGS-1); 
				SQL_ReadResult(query,31,gBindKeyP,MAX_ARGS-1); 
				SQL_ReadResult(query,32,gBindKeyPL,MAX_ARGS-1); 
				SQL_ReadResult(query,33,gBindKeyOS,MAX_ARGS-1); 
				SQL_ReadResult(query,34,gBindKeyOM,MAX_ARGS-1); 
			}
			else if (SQL_NumResults ( query ) < 1)
			{
				get_user_authid(id, authid, 34);
				format(where_statement, 199, "`authid` = '%s'", authid);
				format(mkQuery, 1023, "INSERT INTO %s SET %s", table, where_statement);
				query = SQL_PrepareQuery(db, mkQuery);
				SQL_Execute(query);
				SQL_QueryError(query,error,1023);
				if(error[0])
				{
					log_amx("Could not execute query ^"%s^" -- Error: %s",mkQuery,error);
					load_error[ id ] = true;
					if ( db ) SQL_FreeHandle( db );
					if ( tuple ) SQL_FreeHandle( tuple );
					if ( query ) SQL_FreeHandle( query );
					return 0;
				}
				
				if ( db ) SQL_FreeHandle( db );
				if ( tuple ) SQL_FreeHandle( tuple );
				if ( query ) SQL_FreeHandle( query );
				
				LoadData( id );
				return 0;
			}
		}
	}
	if (db) SQL_FreeHandle( db );
	if (tuple) SQL_FreeHandle( tuple );
	return 0;
}

public FW_FM_Setmodel(ent, model[]){
	new owner = pev(ent, pev_owner);
	if(gHasSuperGrenade[owner]){
		if(equali(model,"models/w_hegrenade.mdl")){
			engfunc(EngFunc_SetModel, ent, gPingwinModelW); 
			return FMRES_SUPERCEDE; 
		} 
	}
	return FMRES_IGNORED;
} 

public eventTouch(toucher, touched){
	new id = entity_get_edict(toucher, EV_ENT_owner); 
	
	if(fm_cs_get_grenade_type_myid(toucher) == He){
		if(gHasSuperGrenade[id]){
			set_task(1.5, "removePing", id + TASK_REMOVED, _, _, "a", 1);
		}
	}
}

public removePing(id){
	id -= TASK_REMOVED;
	gHasSuperGrenade[id] = false;
}

addExp(id, num){
	gXp[id] += num;
	refreshExp(id);
}

refreshExp(id){
	while(gLevel[id] <= 64 && gXp[id] >= gTable[gLevel[id]]){
		gLevel[id] += 1;
		gPoint[id] += 1;
		
		if(gLevel[id] % 10 == 0){
			gPoint[id] += 1;
			ColorChat(id, GREEN,"%s^x01 Gratulacje! Dostajesz ^x04+1^x01 punkt", gPrefix); 
		}
		
		new szName[32];
		get_user_name(id, szName, sizeof szName - 1);
		ColorChat(0, GREEN,"%s^x01 Gratulacje!^x04 %s^x01 osiagnal poziom^x03 %d", gPrefix, szName, gLevel[id]); 
		
		if(is_user_alive(id)){
			new p_origin[3];
			get_user_origin(id, p_origin, 0);
			
			set_sprite(p_origin, sprite_lvlup, 30);
		}
	}
}

public blockMoney(id){
	if(1<= id <= 32 && is_user_connected(id) && gPlayerMoney[id] != read_data(1)){
		cs_set_user_money(id,gPlayerMoney[id],0);
	}
}

public giveMoney(id, level, cid){
	if (!(get_user_flags(id) & ADMIN_IMMUNITY)){
		console_print(id,"[AMXX] Nie masz uprawnien..");
		return PLUGIN_HANDLED;
	}
	
	new targetarg[32];
	read_argv(1, targetarg, 31);
	new target = cmd_target(id, targetarg, 11);
	
	if(!target)
		return PLUGIN_HANDLED;
	
	new name[32];
	get_user_name(target, name, 31);
	
	gPlayerMoney[target] += 10;
	cs_set_user_money(target,gPlayerMoney[target],1)
	console_print(id,"[ExpMod] Dales ^"%s^" 5$ (Obecnie posiada %i$)", name, gPlayerMoney[target]);
	
	return PLUGIN_CONTINUE;
}

public rules(id,lvl,cid){
	if(!(get_user_flags(id) & ADMIN_MENU)){
		console_print(id,"[AMXX] Nie masz uprawnien");
		return PLUGIN_HANDLED;
	}
	
	new user[32], message[128], uid;
	read_argv(1, user, 32);
	new jezyk[3];
	get_user_info(id, "lang", jezyk, 2);
	
	if(equal(jezyk, "pl")) format(message,127,"say /zasady");
	else format(message,127,"say /rules");
	
	uid = find_player("bh",user);
	
	if(uid == 0){
		console_print(id,"[AMXX] Podales nieporawny nick");
		return PLUGIN_HANDLED;
	}
	client_cmd(uid,"%s",message);
	return PLUGIN_CONTINUE;
}

public changeUserMoney(id,ile){
	gPlayerMoney[id] += ile;
	cs_set_user_money(id,gPlayerMoney[id],1);
}

public blockBoom(){
	if (get_msg_args() != 8)
	return 0;
	
	if (get_msg_arg_int(1) != 3 || get_msg_arg_int(6) != 25 || get_msg_arg_int(7) != 30 || get_msg_arg_int(8) != 0)
	return 0;
	
	gOrigin[0] = get_msg_arg_float(2);
	gOrigin[1] = get_msg_arg_float(3);
	gOrigin[2] = get_msg_arg_float(4);
	
	genericShock(gOrigin, 575.0, "weaponbox", 32, 3.0, OBJECT_GENERIC);
	genericShock(gOrigin, 575.0, "armoury_entity", 32, 3.0, OBJECT_ARMOURY);
	genericShock(gOrigin, 575.0, "grenade", 32, 3.0, OBJECT_GRENADE);
	genericShock(gOrigin, 575.0, "hostage_entity", 32, 3.0, OBJECT_GENERIC);
	
	return 0;
}

public set_sprite(p_origin[3], sprite, radius)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, p_origin);
	write_byte(TE_EXPLOSION);
	write_coord(p_origin[0]);
	write_coord(p_origin[1]);
	write_coord(p_origin[2]);
	write_short(sprite_lvlup);
	write_byte(radius);
	write_byte(30);
	write_byte(4);
	message_end();
}

set_bartime(id, czas, startprogress=0){
	message_begin((id)?MSG_ONE:MSG_ALL, get_user_msgid("BarTime2"), _, id)
	write_short(czas);
	write_short(startprogress);
	message_end();   
}

genericShock(Float:hitPointOrigin[3], Float:radius, classString[], maxEntsToFind, Float:power, OBJECTTYPE:objecttype) { // bool:isthisplayer, bool:isthisarmouryentity, bool:isthisgrenade/*, Float:pullup*/) {
	new entList[32];
	if (maxEntsToFind > 32)
	maxEntsToFind = 32;
	
	new entsFound = find_sphere_class(0, classString, radius, entList, maxEntsToFind, hitPointOrigin);
	
	new Float:entOrigin[3];
	new Float:velocity[3];
	new Float:cOrigin[3];
	
	for (new j = 0; j < entsFound; j++) {
		switch (objecttype){
		case OBJECT_PLAYER:{
				if (!is_user_alive(entList[j]))
				continue;
			}
		case OBJECT_GRENADE:{
				new l_model[16];
				entity_get_string(entList[j], EV_SZ_model, l_model, 15);
				if (equal(l_model, "models/w_c4.mdl"))
				continue;
			}
		}
		
		entity_get_vector(entList[j], EV_VEC_origin, entOrigin);
		
		new Float:distanceNadePl = vector_distance(entOrigin, hitPointOrigin);
		
		if(entity_get_int(entList[j], EV_INT_flags) & FL_ONGROUND && entOrigin[2] < hitPointOrigin[2])
		entOrigin[2] = hitPointOrigin[2] + distanceNadePl;
		
		entity_get_vector(entList[j], EV_VEC_velocity, velocity);
		
		cOrigin[0] = (entOrigin[0] - hitPointOrigin[0]) * radius / distanceNadePl + hitPointOrigin[0];
		cOrigin[1] = (entOrigin[1] - hitPointOrigin[1]) * radius / distanceNadePl + hitPointOrigin[1];
		cOrigin[2] = (entOrigin[2] - hitPointOrigin[2]) * radius / distanceNadePl + hitPointOrigin[2];
		
		velocity[0] += (cOrigin[0] - entOrigin[0]) * power;
		velocity[1] += (cOrigin[1] - entOrigin[1]) * power;
		velocity[2] += (cOrigin[2] - entOrigin[2]) * power;
		
		entity_set_vector(entList[j], EV_VEC_velocity, velocity);
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
