#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>
#include <cstrike>
#include <engine>
#include <hamsandwich>
#include <sqlx>
#include <ColorChat>
#include <fun>

#define HUD_DELAY 			2.0
#define MINIMUM_FALL_SPEED 		10
#define MAXIMUM_DAMAGE_FROM_JUMP 	70.0
#define DAMAGE 				60.0
#define DELAY 				0.20
#define ILOSC_UZYWEK			9
#define ILOSC_POZIOMOW			66
#define	ILOSC_TIMEROW			2
#define	ILOSC_DAMAGE			33
#define MAX_LEN				32
#define MAX_ARGS			4
#define IsPlayer(%1) 			(1 <= %1 <= get_maxplayers())
#define CTRLKEY_1 			IN_USE
#define CTRLKEY_2 			IN_ATTACK2

enum(*= 7){
	TASK_STEALTH,
	TASK_KAMUFLAZ,
	TASK_GUN,
	TASK_ZES,
	TASK_PING,
	TASK_KAR,
	TASK_REMOVED,
	TASK_TRAP
};

enum _:Grenade{
	Flashbang,
	He,
	Smokee,
	C4
}

static const 	gPrefix[] 		= "[4Fragers.com]";
static const 	gThunderSound[] 	= "ambience/thunder_clap.wav";
static const 	gPushSound[] 		= "4Fragers/push.wav";
static const 	gStealthSound[] 	= "4Fragers/stealth.wav";
static const 	gCamouflageSound[] 	= "4Fragers/camouflage.wav";
static const 	gBlindSound[] 		= "scientist/scream21.wav";
static const 	gOddechSound[] 		= "4Fragers/oddech.wav";
static const 	gMoneySound[] 		= "4Fragers/money.wav";
static const 	gAuraModel[] 		= "models/4Fragers/aura.mdl";
static const	gPingwinModelW[]	= "models/4Fragers/w_grenade.mdl";
static const	gPingwinModelP[]	= "models/4Fragers/p_grenade.mdl";
static const	gPingwinModelV[]	= "models/4Fragers/v_grenade.mdl";
static const	gPulapkaModel[]		= "models/4Fragers/pulapka.mdl";
static const	gPulapkaClassname[]	= "xp_pulapka";
static const	gBoomSound[]		= "misc/killChicken.wav";
static const	gBoingSound[]		= "4Fragers/boing.wav";
static const 	gAuraClassname[] 	= "xp_aura";

new		giLastSingle[33],
g_max_clients,
g_menu_player[33];

new 		gXp[33],
gLevel[33],
gBonus[33],
gPoint[33],
gPlayerMoney[33],
gSkill0[33],
gSkill1[33],
gSkill2[33],
gSkill3[33],
gSkill4[33],
gSkill5[33],
gSkill6[33],
gSkill7[33],
gSkill8[33],
gSkill9[33],
gSkill10[33],
gSkill11[33],
gSkill12[33],
gSkill13[33],
gSkill14[33],
gSkill15[33],
gSkill16[33],
gSkill17[33],
gSkill18[33],
gSkill19[33],
gSkill20[33],
gSkill21[33],
gSkill22[33],
gUsed[33][ILOSC_UZYWEK];

new bool:	gHasSuperGrenade[33],
gCantMove[33],
gStop[33],
iSklepikUse[33][7],
bWeapon[33],
bUsed[33];

new 		Float:gfDamage[33][ILOSC_DAMAGE],
Float:gfOrigin[3],
Float:gfTime[33][ILOSC_TIMEROW],
Float:gOrigin[3];

new		gStatusMsg,
gArmorMsg,
gScreenFadeMsg,
sprite_lvlup,
sprite_freez,
sprite_blood,
sprite_bloodspray,
sprite_lightning,
sprite_smoke,
sprite_push;

new const gStealth[6]={
	7,
	8,
	9,
	11,
	17,
	0
};	

/*TABELA XP*/
new const gTable[ILOSC_POZIOMOW] = {
	250,  // 1
	600,  // 2
	1000, // 3
	1500, // 4
	2000, // 5
	2500, // 6
	3000, // 7
	3500, // 8
	4000, // 9
	5500, // 10
	6000, // 11
	7000, // 12
	8000, // 13
	9000, // 14
	10000, // 15
	11000, // 16
	13000, // 17
	15000, // 18
	17000, // 19
	20000, // 20
	23500, // 21
	26600, // 22
	30000, // 23
	33900, // 24
	37000, // 25
	40100, // 26
	44500, // 27
	48000, // 28
	51999, // 29
	54500, // 30
	59000, // 31
	63000, // 32   
	67500, // 33
	70900, // 34
	75100, // 35
	79999, // 36
	83500, // 37
	87750, // 38
	91000, // 39
	95500, // 40
	99900, // 41
	103500,// 42
	107000,// 43
	110500,// 44
	114900,// 45
	118900,// 46
	121000,// 47
	125500,// 48
	130000,// 49
	140000,// 50
	151000,// 51
	163000,// 52
	175000,// 53
	187000,// 54
	199000,// 55
	212000,// 56
	226000,// 57
	239000,// 58
	252000,// 59
	266000,// 60
	278000,// 61
	313000,// 62
	405000,// 63
	546000,// 64
	750000 // 65
};

enum OBJECTTYPE{
	OBJECT_GENERIC,
	OBJECT_GRENADE,
	OBJECT_PLAYER,
	OBJECT_ARMOURY
};

new szSklepikMenu[][]={
	"Flesh",
	"Smoke",
	"He",
	"Dodatkowy Exp - (500 XP)",
	"Losowa bron",
	"Naboje",
	"Respawn"
}

new iSklepikKoszt[]={
	5,
	10,
	10,
	100,
	20,
	15,
	25
}

/*
CREATE TABLE IF NOT EXISTS `expmod`
(
`authid` VARCHAR(32),
`xp` INT(10),
`lvl` INT(10),
`pkt` INT(10),
`money` INT(10),
`gSkill1` INT(10),
`gSkill2` INT(10),
`gSkill3` INT(10),
`gSkill4` INT(10),
`gSkill5` INT(10),
`gSkill6` INT(10),
`gSkill7` INT(10),
`gSkill8` INT(10),
`gSkill9` INT(10),
`gSkill10` INT(10),
`gSkill11` INT(10),
`gSkill12` INT(10),
`gSkill13` INT(10),
`gSkill14` INT(10),
`gSkill15` INT(10),
`gSkill16` INT(10),
`gSkill17` INT(10),
`gSkill18` INT(10),
`gSkill19` INT(10),
`gSkill20` INT(10),
`gSkill21` INT(10),
`gSkill22` INT(10)
*/


new 	Handle:tuple, 
Handle:db, 
Handle:query, 
mkQuery[2048], 
error[2048], 
errcode, 
load_error[33];

/*WYWOLYWANE NA POCZATKU MAPY*/
public plugin_init() {
	register_plugin("4Fragers EXP MOD", "0.1", "pcheLa");
	
	gStatusMsg 	= get_user_msgid("StatusText");
	gArmorMsg  	= get_user_msgid("ArmorType");
	gScreenFadeMsg 	= get_user_msgid("ScreenFade");
	
	register_message(23, "blockBoom");
	register_event("Money", "blockMoney", "b");
	
	register_logevent("Koniec_Rundy", 2, "1=Round_End");
	
	register_forward(FM_EmitSound, "FW_FM_Sound") ;
	register_forward(FM_Touch, "FW_FM_Touch");
	register_forward(FM_PlayerPreThink, "FW_FM_Prethink");
	register_forward(FM_SetModel, "FW_FM_Setmodel");
	register_think(gAuraClassname, "FW_FM_AuraThink");
	register_event("DeathMsg", "eventDeath", "a");
	register_event("CurWeapon", "eventCurWeapon", "be", "1=1");
	register_logevent("eventRoundstart", 2, "1=Round_Start");
	RegisterHam(Ham_Touch, "grenade", "eventTouch");
	RegisterHam(Ham_Spawn, 	"player", "eventPlayerSpawn",  1	);
	RegisterHam(Ham_TakeDamage, "player", "eventDamage", 0);
	
	set_task(HUD_DELAY, "writeHud",0, "", 0, "b");
	
	register_clcmd("say /reset", "doReset");
	register_clcmd("say_team /reset", "doReset");
	register_clcmd("say /xp", "openMenu");
	register_clcmd("say_team /xp", "openMenu");
	register_clcmd("say /exp", "openMenu");
	register_clcmd("say_team /exp", "openMenu");
	register_clcmd("say /sklep","menuSklep");
	register_clcmd("say_team /sklep","menuSklep");
	register_clcmd("say /gracze","menuGracze");
	register_clcmd("say_team /gracze","menuGracze");
	
	register_concmd("amx_givemoney", "giveMoney", ADMIN_IMMUNITY, "<nick>");
	register_concmd("amx_zasady", "rules", ADMIN_MENU, "<nick>");
	
	register_clcmd("+skill", "doThunder");
	register_clcmd("+skill2", "doAura");
	register_clcmd("+skill3", "doStealth");
	register_clcmd("+skill4", "doKamuflaz");
	register_clcmd("+skill5", "doPush");
	register_clcmd("+skill6", "doTrap");
	register_clcmd("+skill7", "doBlind");
	register_clcmd("+skill8", "doOddech");
	
	register_menucmd(register_menuid("MainMenu"), 1023, "handleMainMenu");
	register_menucmd(register_menuid("SkillMenu"), 1023, "handleSkillMenu");
	register_menucmd(register_menuid("Skill2Menu"), 1023, "handleSkill2Menu");
	register_menucmd(register_menuid("Skill3Menu"), 1023, "handleSkill3Menu");
	register_menucmd(register_menuid("SSMenu"), 1023, "handleSSMenu");
	
	register_menucmd(register_menuid("HPMenu"), 1023, "handleHPMenu"); // Zycie
	register_menucmd(register_menuid("APMenu"), 1023, "handleAPMenu"); // Armor
	register_menucmd(register_menuid("KRMenu"), 1023, "handleKRMenu"); // Ciche kroki
	register_menucmd(register_menuid("RSMenu"), 1023, "handleRSMenu"); // Odrodzenie
	register_menucmd(register_menuid("PRMenu"), 1023, "handlePRMenu"); // Blyskawica
	register_menucmd(register_menuid("ARMenu"), 1023, "handleARMenu"); // Aura zycia
	register_menucmd(register_menuid("STMenu"), 1023, "handleSTMenu"); // Niewidzialnosc
	register_menucmd(register_menuid("KMMenu"), 1023, "handleKMMenu"); // Kamuflaz
	register_menucmd(register_menuid("PSMenu"), 1023, "handlePSMenu"); // Pistolety
	register_menucmd(register_menuid("SGMenu"), 1023, "handleSGMenu"); // Stalowa glowa
	register_menucmd(register_menuid("PHMenu"), 1023, "handlePHMenu"); // Odepchniecie
	register_menucmd(register_menuid("XPMenu"), 1023, "handleXPMenu"); // Dodatkowy exp
	register_menucmd(register_menuid("GRMenu"), 1023, "handleGRMenu"); // Latajacy Pingwin
	register_menucmd(register_menuid("BRMenu"), 1023, "handleBRMenu"); // Lustrzana bariera
	register_menucmd(register_menuid("OBMenu"), 1023, "handleOBMenu"); // Gumowe buty
	register_menucmd(register_menuid("MGMenu"), 1023, "handleMGMenu"); // Karabiny
	register_menucmd(register_menuid("KSMenu"), 1023, "handleKSMenu"); // Dodatkowe obrazenia
	register_menucmd(register_menuid("PLMenu"), 1023, "handlePLMenu"); // Pulapka
	register_menucmd(register_menuid("ZSMenu"), 1023, "handleZSMenu"); // Zestaw broni
	register_menucmd(register_menuid("OSMenu"), 1023, "handleOSMenu"); // Oslepienie
	register_menucmd(register_menuid("WZMenu"), 1023, "handleWZMenu"); // Wzmocnienie
	register_menucmd(register_menuid("SS2Menu"), 1023, "handleSS2Menu"); // Super skok
	register_menucmd(register_menuid("OMMenu"), 1023, "handleOMMenu"); // Oddech Mrozu
	
	set_task(75.0,"bestPlayer");
	
	register_cvar("expmod_sql_host","85.232.255.138",FCVAR_PROTECTED);
	register_cvar("expmod_sql_user","busydays_test",FCVAR_PROTECTED);
	register_cvar("expmod_sql_pass","D9gjZqTB",FCVAR_PROTECTED);
	register_cvar("expmod_sql_db","busydays_test",FCVAR_PROTECTED);
	register_cvar("expmod_sql_table","expmod",FCVAR_PROTECTED);
}

public bestPlayer(){
	new Players[32], playerCount, i, id , lvlstop=0,xpjego=0,www=0;
	new name[32];
	get_players(Players, playerCount, "c");
	for(i=0; i<playerCount; i++){
		id = Players[i];
		if(gXp[id]>lvlstop){
			get_user_name(id,name,31);
			lvlstop=gXp[id];
			xpjego=gLevel[id];
			www=1;
			
		}
		client_cmd(id,"cl_minmodels 0;wait;ex_interp 0.01;wait;hud_centerid 0");
	}
	if(www==1){
		ColorChat(0, GREEN, "^x04%s^x01 Najlepszy gracz z grajacych to ^x04%s ^x03(%i) (%i)" ,gPrefix, name, xpjego, lvlstop);
	}	
	set_task(200.0,"bestPlayer");
}

public Koniec_Rundy()
{
	new exp_to_give;
	for(new i = 1;i<33;i++){
		if(!is_user_alive(i) || get_user_team(i) != 1){
			continue;
		}
		exp_to_give = 5;
		if(get_user_flags(i) & ADMIN_LEVEL_F){
			exp_to_give += 5;
		}
		addExp(i, exp_to_give);
		ColorChat(i, GREEN, "%s^x01 Otrzymales^x03 %d XP^x01 za przezycie rundy!", gPrefix,exp_to_give);
	}
}

public eventDamage(victim, inflicter, attacker, Float:fDamage, bitDamage){
	if(!is_user_alive(victim) || !is_user_connected(victim) || !is_user_connected(attacker))
	return HAM_IGNORED;
	
	if(gSkill16[attacker]){
		if(get_user_weapon(attacker) == CSW_KNIFE){
			SetHamParamFloat(4, fDamage + float((gSkill16[attacker] * 2) + gSkill19[attacker]));
		}
	}
	
	if(gSkill13[victim]){
		if(IsPlayer(attacker)){
			new random = random_num(1, 100);
			
			if(random <= (gSkill13[victim] * 3)){
				new szName[32];
				get_user_name(attacker, szName, sizeof szName - 1);
				
				SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill13[victim]) / 10.0)));
				ExecuteHam(Ham_TakeDamage, attacker, "", victim, fDamage * (1.0 - (float(gSkill13[victim]) / 10.0)), 1);
				set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 3.0, 3.2, 1.1, 1.1, 3);
				show_hudmessage(victim, "[XP] Przyjales mniejsze obrazenia [%.1f zamiast %.1f]^n%s Przyjal [%.1f] obrazen na siebie!", fDamage * (1.0 - (float(gSkill13[victim]) / 10.0)), fDamage, szName, fDamage * (1.0 - (float(gSkill13[victim]) / 10.0)));
			}
		}
	}
	
	if(gHasSuperGrenade[attacker]){
		if (bitDamage & (1<<24)){
			if(cs_get_user_team(victim) == CS_TEAM_T){
				new Float:upVector[3];
				upVector[0] = float(read_data(4));
				upVector[1] = float(read_data(5));
				upVector[2] = float(read_data(6));
				
				set_velocity_from_origin(victim, upVector, 1315.0);
			}
			SetHamParamFloat(4, 0.0);
		}
	}
	
	if(gSkill14[victim]){
		if(bitDamage & DMG_FALL){
			SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill14[victim]) / 10.0)));
		}
	}
	return HAM_HANDLED;
}

public removeStuck(id){
	id -= TASK_TRAP;
	
	if(!is_user_alive(id)) return 1;
	
	gCantMove[id] = false;
	set_pev(id, pev_maxspeed, 250.0);
	set_pev(id, pev_gravity, 1.0);
	
	set_task(0.2, "eventCurWeapon", id);
	
	return 0;
}

public FW_FM_Sound(entity, channel, const sound[]){
	new owner = pev(entity, pev_owner);
	if(gHasSuperGrenade[owner]){
		if(equal(sound, "weapons/he_bounce-1.wav")){
			emit_sound(entity ,CHAN_ITEM, gBoingSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
			return FMRES_SUPERCEDE;
		}
		if(contain(sound, "weapons/debris") != -1){
			emit_sound(entity ,CHAN_ITEM, gBoomSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}

public eventRoundstart(){
	new ent = -1;
	while((ent = fm_find_ent_by_class(ent, gAuraClassname)))
	{
		engfunc(EngFunc_RemoveEntity, ent);
		
	}
	
	ent = -1;
	while((ent = fm_find_ent_by_class(ent, gPulapkaClassname)))
	{
		engfunc(EngFunc_RemoveEntity, ent);
		
	}
	
	new iPlayers[32], iNum;
	get_players(iPlayers, iNum);
	
	for(new i=0;i<iNum;i++){
		gHasSuperGrenade[iPlayers[i]] = false;
	}
}

public plugin_precache(){
	sprite_blood = 		engfunc(EngFunc_PrecacheModel, "sprites/blood.spr");
	sprite_bloodspray =	engfunc(EngFunc_PrecacheModel, "sprites/bloodspray.spr");
	sprite_lightning = 	engfunc(EngFunc_PrecacheModel, "sprites/lgtning.spr");
	sprite_smoke = 		engfunc(EngFunc_PrecacheModel, "sprites/steam1.spr");
	sprite_push =		engfunc(EngFunc_PrecacheModel, "sprites/shockwave.spr");
	sprite_freez = 		engfunc(EngFunc_PrecacheModel, "sprites/4Fragers/oddech.spr");
	sprite_lvlup = 		engfunc(EngFunc_PrecacheModel, "sprites/4Fragers/lvlup.spr");
	
	engfunc(EngFunc_PrecacheSound, gPushSound);
	engfunc(EngFunc_PrecacheSound, gThunderSound);
	engfunc(EngFunc_PrecacheSound, gBoomSound);
	engfunc(EngFunc_PrecacheSound, gBoingSound);
	engfunc(EngFunc_PrecacheSound, gStealthSound);
	engfunc(EngFunc_PrecacheSound, gCamouflageSound);
	engfunc(EngFunc_PrecacheSound, gBlindSound);
	engfunc(EngFunc_PrecacheSound, gOddechSound);
	engfunc(EngFunc_PrecacheSound, gMoneySound);
	
	engfunc(EngFunc_PrecacheModel, gPingwinModelW);
	engfunc(EngFunc_PrecacheModel, gPingwinModelV);
	engfunc(EngFunc_PrecacheModel, gPingwinModelP);
	engfunc(EngFunc_PrecacheModel, gPulapkaModel);
	engfunc(EngFunc_PrecacheModel, gAuraModel);
}
/*KONIEC WYWOLYWANYCH NA POCZATKU MAPY*/
/*FORWARDY*/
public FW_FM_Touch(toucher, touched, entity, id){
	if(!is_user_alive(toucher) || !is_user_alive(touched)) 
	return;
	
	new touched_origin[3], toucher_origin[3];
	get_user_origin(touched, touched_origin); 
	get_user_origin(toucher, toucher_origin);
	new Float:toucher_minsize[3], Float:touched_minsize[3];
	pev(toucher, pev_mins, toucher_minsize);
	pev(touched, pev_mins, touched_minsize);
	
	if(touched_minsize[2] != -18.0) {
		if(!(toucher_origin[2] == touched_origin[2]+72 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+54 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	else {
		if(!(toucher_origin[2] == touched_origin[2]+68 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+50 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	
	new flags = entity_get_int(touched, EV_INT_flags);
	
	if (flags & FL_ONGROUND){
		if(is_user_alive(touched) && gfDamage[toucher][touched] <= get_gametime()){
			gfDamage[toucher][touched] = get_gametime() + DELAY;
			smashHead(touched, toucher, DAMAGE - float((gSkill9[touched] * 7)));
		}
	}
}

public FW_FM_Prethink(id){
	if(!is_user_alive(id)){
		return FMRES_IGNORED;
	}
	if(gStop[id]){
		set_pev(id,pev_velocity,Float:{0.0,0.0,0.0}); // stop motion
		engfunc(EngFunc_SetClientMaxspeed,id,0.00001); // keep immobile
	}
	static button
	button = pev(id, pev_button);
	new iCtrl1 = !(!(button&CTRLKEY_1));
	new iCtrl2 = !(!(button&CTRLKEY_2));
	
	if(iCtrl1 ^ iCtrl2)
	giLastSingle[id] = 1;
	else if(giLastSingle[id]){
		giLastSingle[id] = 0;
		if(iCtrl1 && iCtrl2 && gSkill21[id] == 15 && !gUsed[id][7]){
			message_begin(MSG_ONE,get_user_msgid("StatusIcon")  ,{0,0,0},id)  
			write_byte(1)  
			write_string("item_longjump");
			write_byte(255); // red
			write_byte(0); // green
			write_byte(0); // blue
			message_end();
			gUsed[id][7] = true;
			new Float:fl_iNewVelocity[3];
			VelocityByAim(id, 500, fl_iNewVelocity);
			fl_iNewVelocity[2] = 150.0;
			entity_set_vector(id, EV_VEC_velocity, fl_iNewVelocity);
		}
	}
	static oldbutton;
	button =	pev(id, pev_button);
	oldbutton =	pev(id, pev_oldbuttons);
	
	if((button & IN_RELOAD) && !(oldbutton & IN_RELOAD)){
		WyswietlSSMenu(id);
	}
	
	if(gSkill2[id] && get_user_team(id) == 2){
		set_pev(id, pev_flTimeStepSound, 999);
	}
	
	return FMRES_IGNORED;
}

/*KONIEC FORWARDOW*/
/*EVENTY*/
public eventPlayerSpawn(id){
	gUsed[id][0] = false;
	gUsed[id][1] = false;
	gUsed[id][2] = false;
	gUsed[id][3] = false;
	gUsed[id][4] = false;
	gUsed[id][5] = false;
	gUsed[id][6] = false;
	gUsed[id][7] = false;
	gUsed[id][8] = false;
	bWeapon[id] = false;
	bUsed[id] = false;
	
	if(!is_user_alive(id)) return 1;
	
	for(new j = 0;j<7;j++){
		iSklepikUse[id][j] = false;
	}
	set_pev(id, pev_health, float(100 + ((gSkill0[id] * 10) + gSkill19[id])));
	fm_add_user_armor(id, float((gSkill1[id] * 20) + (gSkill19[id] * 5)), 2);
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 0);
	
	if(task_exists(id + TASK_GUN)) remove_task(id + TASK_GUN);
	if(task_exists(id + TASK_KAR)) remove_task(id + TASK_KAR);
	if(task_exists(id + TASK_ZES)) remove_task(id + TASK_ZES);
	if(task_exists(id + TASK_PING)) remove_task(id + TASK_PING);
	
	if(get_user_team(id) == 2)
	set_task(10.0, "tryPingwin", id + TASK_PING, _, _, "a", 1);
	gCantMove[id] = false;
	set_task(10.1, "tryGun", id + TASK_GUN, _, _, "a", 1);
	set_task(10.2, "tryKar", id + TASK_KAR, _, _, "a", 1);
	set_task(10.3, "tryZes", id + TASK_ZES, _, _, "a", 1);
	set_task(1.0,"tryIcon",id+1111)
	return 0;
}

public tryIcon(id){
	id -= 1111;
	if(gSkill21[id] == 15 && is_user_alive(id)){
		message_begin(MSG_ONE, get_user_msgid("StatusIcon") ,{0,0,0}, id); 
		write_byte(1);
		write_string("item_longjump");
		write_byte(0); // red
		write_byte(255); // green
		write_byte(0); // blue
		message_end();
	}
}

public eventDeath(){ 
	new attacker 	= read_data(1); 
	new victim 	= read_data(2);
	
	new bool:bHasAccess = bool:(get_user_flags(attacker) & ADMIN_LEVEL_F);
	new exp_to_give;
	
	if(IsPlayer(attacker)){	
		if(get_user_team(victim) == 2 && get_user_team(attacker) == 1){
			new iCt = 0,iTt=0;
			for(new i = 1;i<33;i++){
				if(!is_user_alive(i) || get_user_team(i) != 2){
					continue;
				}
				iCt++;
			}
			for(new i = 1;i<33;i++){
				if(!is_user_alive(i) || get_user_team(i) != 1){
					continue;
				}
				iTt++;
			}
			if(iCt == 1 && iTt > 1){
				set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 3);
				show_hudmessage(0, "UWAGA! Pozostal ostatni CT, schodzimy z kamp"); 
			}
			if(iCt == 1 && iTt == 1){
				set_hudmessage(127, 255, 85, -1.0, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 3);
				show_hudmessage(0, "UWAGA! Jest 1 vs 1, mozna podpowiadac!"); 
			}
		}
		if(get_user_team(attacker) != get_user_team(victim)){
			gBonus[attacker] = 0;
			
			exp_to_give = 10;
			
			if(gLevel[victim] >= (gLevel[attacker] + 25)) 					{ gBonus[attacker] = 25; exp_to_give += 15; }
			if(!gBonus[attacker] && gLevel[victim] >= (gLevel[attacker] + 5)) 		{ gBonus[attacker] = 5;exp_to_give += 10; }
			if(bHasAccess) 									{ exp_to_give += 5; }
			
			if(gSkill11[attacker] >= 5)
			exp_to_give += (gSkill11[attacker] / 5 + gSkill19[attacker] / 2);
			
			addExp(attacker, exp_to_give);
			
			ColorChat(attacker, GREEN, "%s^x01 Otrzymales^x03 %d XP^x01 za%s%s%s", gPrefix, exp_to_give, gBonus[attacker] == 0 ? " zabicie" : "", gBonus[attacker] == 5 ? " zabicie gracza minimum 5 poziomow lepszego" : "", gBonus[attacker] == 25 ? " zabicie gracza minimum 25 poziomow lepszego" : "");
			
			gBonus[attacker] = 0;
			
			if(random_num(1,100)<=5){
				changeUserMoney(attacker,5);
				client_cmd(attacker, "spk 4Fragers/money.wav");
			}
		}
	}
	set_task(1.0, "removeEff", victim);
	if(task_exists(victim + TASK_STEALTH)) remove_task(victim + TASK_STEALTH);
	if(task_exists(victim + TASK_GUN)) remove_task(victim + TASK_GUN);
	if(task_exists(victim + TASK_PING)) remove_task(victim + TASK_PING);
	set_task(1.0, "respawn_player", victim);
}

public removeEff(victim) set_pev(victim, pev_effects, EF_NODRAW);

public eventCurWeapon(id){
	if(!is_user_alive(id))
	return 0;
	
	if(gCantMove[id]){
		set_pev(id, pev_maxspeed, 0.1);
		set_pev(id, pev_gravity, 3.0);
	}
	if(get_user_weapon(id) == CSW_HEGRENADE && gHasSuperGrenade[id]){	
		set_pev(id, pev_viewmodel2, gPingwinModelV);
		set_pev(id, pev_weaponmodel2, gPingwinModelP);
		client_cmd(id, "spk 4Fragers/boing.wav");
	}
	
	return 0;
}

public client_connect(id){
	gPlayerMoney[id] = 0;
	LoadData(id);
	bUsed[id] = false;
	gStop[id] = false;
	bWeapon[id] = false;
	gBonus[id] = 0;
	gHasSuperGrenade[id] = false;
	client_cmd(id, "cl_minmodels 0");
}

public client_disconnect(id){
	SaveData(id);
}
/*KONIEC EVENTOW*/
/*MENU*/
public menuGracze(id){
	static title[512];
	formatex(title, sizeof(title) - 1, "[ExpMod] Wybierz gracza:");
	
	new menu = menu_create(title, "MenuPlayer");
	
	new name[32], authid[35];
	
	for( new i = 1; i <= g_max_clients; i++ ){
		if( !is_user_connected(i) ) continue;
		
		get_user_name(i, name, sizeof(name) - 1);
		get_user_authid(i, authid, sizeof(authid) - 1);
		
		menu_additem(menu, name, authid);
	}
	
	menu_setprop(menu, MPROP_EXITNAME, "Wyjscie");
	menu_display(id, menu);
}

public MenuPlayer(client, menu, item){
	if(is_user_connected(client)){
		if( item == MENU_EXIT ){
			menu_destroy(menu);
			return;
		}
		
		static _access, authid[35], callback;
		menu_item_getinfo(menu, item, _access, authid, sizeof(authid) - 1, _, _, callback);
		menu_destroy(menu);
		
		new player = find_player("c", authid);
		if( !is_user_connected(player) ){
			return;
		}
		
		g_menu_player[client] = player;
		new name[32];
		get_user_name(player, name, sizeof(name) - 1);
		
		new tempstring[100];
		new motd[2048];
		formatex(motd,charsmax(motd),"<body text=^"#FFB000^" bgcolor=^"#000000^"><strong><font size=2><center>Informacje o ^"%s^"</center>",name);
		add(motd,charsmax(motd),"<br><hr>");
		
		formatex(tempstring,charsmax(tempstring),"Level: %i Exp: %i Kasa: %i", gLevel[player], gXp[player], gPlayerMoney[player]);
		add(motd,charsmax(motd),tempstring);
		add(motd,charsmax(motd),"<br><br>");
		
		show_motd(client,motd,"Informacje");
	}
}

public menuSklep(id){
	new szTmp[64];
	formatex(szTmp,charsmax(szTmp),"%s - Sklepik",gPrefix)
	new pMenu = menu_create(szTmp,"menuSklepHandle")
	for(new i = 0;i<sizeof szSklepikMenu;i++){
		formatex(szTmp,charsmax(szTmp),"%s \r[%d$]",szSklepikMenu[i],iSklepikKoszt[i]);
		menu_additem(pMenu,szTmp);
	}
	menu_setprop(pMenu,MPROP_EXITNAME,"Wyjscie")
	menu_setprop(pMenu,MPROP_NUMBER_COLOR,"\r")
	menu_display(id,pMenu)
	return PLUGIN_HANDLED;
}

public menuSklepHandle(id, menu, item){
	if(item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	if(iSklepikKoszt[item] > gPlayerMoney[id]){
		ColorChat(id, GREEN, "%s^x01 Masz za malo kasy!", gPrefix)
		menu_destroy(menu);
		menuSklep(id)
		return PLUGIN_HANDLED;
	}
	if(iSklepikUse[id][item]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles!", gPrefix)
		menu_destroy(menu);
		menuSklep(id)
		return PLUGIN_HANDLED;
	}
	switch(item){
	case 0:{
			fm_give_item(id, "weapon_flashbang");
		}
	case 1:{
			fm_give_item(id, "weapon_smokegrenade");
		}
	case 2:{
			fm_give_item(id, "weapon_hegrenade");
		}
	case 3:{
			gXp[id] += 500;
			refreshExp(id)
		}
	case 4:{
			static iWeapons[]={
				CSW_FAMAS, 
				CSW_AWP, 
				CSW_AUG, 
				CSW_AK47,
				CSW_USP, 
				CSW_DEAGLE, 
				CSW_P228, 
				CSW_FIVESEVEN
			}
			new iRand = iWeapons[random_num(0,sizeof iWeapons - 1)]
			new szWeapName[64];
			get_weaponname(iRand,szWeapName,charsmax(szWeapName))
			fm_give_item(id,szWeapName)
			cs_set_user_bpammo(id, iRand, 0);
			cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), 1);
		}
	case 5:{
			new iWeapons[32], iNum
			get_user_weapons(id,iWeapons,iNum)
			new szWeapName[64];
			for (new i=0; i<iNum; i++){
				if(iWeapons[i] == 2 || iWeapons[i] == 4 || iWeapons[i] == 6 || iWeapons[i] == 9 || iWeapons[i] == 25 || iWeapons[i] == 29 || iWeapons[i] == 31 || iWeapons[i] == 32){
					continue;
				}
				get_weaponname(iWeapons[i],szWeapName,charsmax(szWeapName))
				if(iWeapons[i] == 1 || iWeapons[i] == 11 || iWeapons[i] == 16 || iWeapons[i] == 17 || iWeapons[i] == 26 || iWeapons[i] == 30){
					cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), cs_get_weapon_ammo(find_ent_by_owner(1, szWeapName, id )) + 2);
				}
				else{
					cs_set_weapon_ammo(find_ent_by_owner(1, szWeapName, id ), cs_get_weapon_ammo(find_ent_by_owner(1, szWeapName, id )) + 1);
				}
			}
		}
	case 6:{
			if(is_user_alive(id)){
				ColorChat(id, GREEN, "%s^x01 Jestes zywy!", gPrefix)
				menu_destroy(menu);
				menuSklep(id)
				return PLUGIN_HANDLED;
			}
			new iIleZyje = 0;
			for(new i = 1;i<33;i++){
				if(i == id || !is_user_alive(i) || get_user_team(id) != get_user_team(i)){
					continue;
				}
				iIleZyje++;
			}
			if(iIleZyje < 2){
				ColorChat(id, GREEN, "%s^x01 Musi byc^x04 2^x01 zywych graczy z twojego teamu!", gPrefix)
				menu_destroy(menu);
				menuSklep(id)
				return PLUGIN_HANDLED;
			}
			set_bartime(id, 10, 0)
			set_task(10.0,"godmode_off",id+6666);
			set_user_godmode(id,1)
			setGlowShell(id,10.0,255,0,0)
			ExecuteHamB(Ham_CS_RoundRespawn, id)
		}
	}
	changeUserMoney(id,-iSklepikKoszt[item]);
	iSklepikUse[id][item] = true;
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public godmode_off(id){
	id -= 6666;
	if(is_user_connected(id)){
		set_user_godmode(id,0)
		setGlowShell(id,0.0);
	}
}

public WyswietlMainMenu(id) {
	new MenuBody[150], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wMenu umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZresetuj umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wSklepik");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wGracze");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MainMenu");
}

public handleMainMenu(id, key){
	switch(key + 1){
	case 1: WyswietlSkillMenu(id);
	case 2: doReset(id);
	case 3: menuSklep(id);
	case 4: menuGracze(id);
	}
	
	return 1;
}

public WyswietlSSMenu(id) {
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "ExpMod\r -\y Menu Skilli");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y1. %sKamuflaz \y|\w [Uzyty: %s\w]", gSkill7[id] ? "\w" : "\r", gUsed[id][3] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y2. %sNiewidzialnosc \y|\w [Uzyta: %s\w]", gSkill6[id] ? "\w" : "\r", gUsed[id][2] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y3. %sOdepchniecie \y|\w [Uzyte: %s\w]", gSkill10[id] ? "\w" : "\r", gUsed[id][4] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y4. %sPostaw pulapke \y|\w [Postawiona : %s\w]", gSkill17[id] ? "\w" : "\r", gUsed[id][5] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y5. %sAura zycia \y|\w [Uzyta: %s\w]", gSkill5[id] ? "\w" : "\r", gUsed[id][1] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y6. %sBlyskawica \y|\w [Uzyta: %s\w]", gSkill4[id] ? "\w" : "\r", gUsed[id][0] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y7. %sOslepienie \y|\w [Uzyte: %s\w]", gSkill20[id] ? "\w" : "\r", gUsed[id][6] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\y8. %sOddech mrozu \y|\w [Uzyte: %s\w]", gSkill22[id] ? "\w" : "\r", gUsed[id][8] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\y0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9);
	
	show_menu(id, keys, MenuBody, 5, "SSMenu");
}


public handleSSMenu(id, key){
	switch(key + 1){
	case 1:{
			doKamuflaz(id); 
			WyswietlSSMenu(id);
		}
	case 2:{
			doStealth(id);
			WyswietlSSMenu(id);
		}
	case 3:{
			doPush(id); 
			WyswietlSSMenu(id); 
		}
	case 4:{
			doTrap(id);
			WyswietlSSMenu(id); 
		}
	case 5:{
			doAura(id);
			WyswietlSSMenu(id); 
		}
	case 6:{
			doThunder(id);
			WyswietlSSMenu(id);
		}
	case 7:{
			doBlind(id);
			WyswietlSSMenu(id);
		}
	case 8:{
			doOddech(id);
			WyswietlSSMenu(id);
		}
	}
	return 1;
}

public WyswietlSkill3Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #3");
	
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wPulapka");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wOdepchniecie \w[\rTT\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wOslepienie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wLatajacy Pingwin \w[\rCT\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wBlyskawica");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wOddech Mrozu");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wAura Zycia");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill3Menu");
}

public handleSkill3Menu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlPLMenu(id);
		}
	case 2:{
			WyswietlPHMenu(id);
		}
	case 3:{
			WyswietlOSMenu(id);
		}
	case 4:{
			WyswietlGRMenu(id);
		}
	case 5:{
			WyswietlPRMenu(id);
		}
	case 6:{
			WyswietlOMMenu(id);
		}
	case 7:{
			WyswietlARMenu(id);
		}
	case 10:{
			WyswietlSkill2Menu(id);
		}
	}
	
	return 1;
}

public WyswietlSkill2Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #2");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wPistolety");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wKarabiny");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wZestaw Broni");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wSuper Skok");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wDodatkowe Obrazenia");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wDodatkowy Exp");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wKamuflaz");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r8. \wNiewidzialnosc");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill2Menu");
}

public handleSkill2Menu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlPSMenu(id);
		}
	case 2:{
			WyswietlMGMenu(id);
		}
	case 3:{
			WyswietlZSMenu(id);
		}
	case 4:{
			WyswietlSS2Menu(id);
		}
	case 5:{
			WyswietlKSMenu(id);
		}
	case 6:{
			WyswietlXPMenu(id);
		}
	case 7:{
			WyswietlKMMenu(id);
		}
	case 8:{
			WyswietlSTMenu(id);
		}
	case 9:{
			WyswietlSkill3Menu(id);
		}
	case 10:{
			WyswietlSkillMenu(id);
		}
	}
	
	return 1;
}

public WyswietlSkillMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\r -\y Menu umiejetnosci #1");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r1. \wZycie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wArmor");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wCiche Kroki");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wOdrodzenie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wWzmocnienie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wStalowa Glowa");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wLustrzane Odbicie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r8. \wGumowe Buty");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SkillMenu");
}

public handleSkillMenu(id, key){
	switch(key + 1){
	case 1:{
			WyswietlHPMenu(id);
		}
	case 2:{
			WyswietlAPMenu(id);
		}
	case 3:{
			WyswietlKRMenu(id);
		}
	case 4:{
			WyswietlRSMenu(id);
		}
	case 5:{
			WyswietlWZMenu(id);
		}
	case 6:{
			WyswietlSGMenu(id);
		}
	case 7:{
			WyswietlBRMenu(id);
		}
	case 8:{
			WyswietlOBMenu(id);
		}
	case 9:{
			WyswietlSkill2Menu(id);
		}
	case 10:{
			WyswietlMainMenu(id);
		}
	}
	
	return 1;
}

public WyswietlPLMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz polozyc niewidzialna Pulapke, gdy przeciwnik w nia wejdzie, utknie na 3 sekundy\w^nWymagany poziom:\y 15\w^nWykupione - [%s\w]^nPunkty umiejetnosci: \y%d\r /\y 1\w", gPoint[id], gSkill17[id] ? "\yTak" : "\rNie", gSkill17[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wWroc");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PLMenu");
}

public handlePLMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill17[id]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill17[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Pulapke^x01 !", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public pfn_touch(id, ent){
	if(is_user_alive(id)){
		new szClassName[32], vOrigin[3];
		get_user_origin(id, vOrigin);
		
		entity_get_string(ent, EV_SZ_classname, szClassName, 31);
		new owner = pev(ent, pev_owner);
		
		if(equal(szClassName, gPulapkaClassname)){
			if(get_user_team(owner) != get_user_team(id)){
				gCantMove[id] = true;
				set_pev(id, pev_maxspeed, 0.1);
				set_pev(id, pev_gravity, 3.0);
				Smoke(vOrigin, 20, 20);
				
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
				write_byte(TE_IMPLOSION);
				write_coord(vOrigin[0]);
				write_coord(vOrigin[1]);
				write_coord(vOrigin[2]);
				write_byte(80);
				write_byte(10);
				write_byte(10); 
				message_end();
				
				set_task(0.2, "eventCurWeapon", id);
				set_task(3.1, "removeStuck", id + TASK_TRAP, _, _, "a", 1);
				
				set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 3);
				show_hudmessage(id, "[XP] Wpadles w Pulapke!");
				engfunc(EngFunc_RemoveEntity, ent);
			}
		}
	}
}

public doTrap(id){
	if(!gSkill17[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][5]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:fOrigin[3], ent;
	entity_get_vector(id, EV_VEC_origin, fOrigin);
	
	ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	set_pev(ent, pev_classname, gPulapkaClassname);
	set_pev(ent, pev_owner, id);
	set_pev(ent, pev_movetype, MOVETYPE_TOSS);
	set_pev(ent, pev_origin, fOrigin);
	set_pev(ent, pev_solid, SOLID_BBOX);
	
	engfunc(EngFunc_SetModel, ent, gPulapkaModel);
	engfunc(EngFunc_SetSize, ent, Float:{-16.0, -16.0, 0.0}, Float:{16.0, 16.0, 2.0});
	
	drop_to_floor(ent);
	
	set_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 64);
	
	client_cmd(id, "spk fvox/blip");
	
	set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 3);
	show_hudmessage(id, "[XP] Postawiles pulapke!");
	
	gUsed[id][5] = true;
	
	return 0;
}

public WyswietlKRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Nie slychac twoich krokow\w^nWykupione - [%s\w]^nPunkty umiejetnosci: \y%d\r /\y 1\w", gPoint[id], gSkill2[id] ? "\yTak" : "\rNie", gSkill2[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KRMenu");
}

public handleKRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill2[id]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill2[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Ciche Kroki^x01 !", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public doThunder(id){
	if(!gSkill4[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][0]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][0] = true;
		new num;
		new vorigin[3], pos[3];
		get_user_origin(target, vorigin);
		
		vorigin[2] -= 26;
		pos[0] = vorigin[0] + 150;
		pos[1] = vorigin[1] + 150;
		pos[2] = vorigin[2] + 800;
		
		Thunder(pos, vorigin);
		Smoke(vorigin, 10, 10);
		
		switch(gSkill4[id]){
		case 1: num = (get_user_health(target) / 10)
		case 2: num = (get_user_health(target) / 8)
		case 3: num = (get_user_health(target) / 6)
		case 4: num = (get_user_health(target) / 4)
		case 5: num = (get_user_health(target) / 2)
		}
		
		ExecuteHam(Ham_TakeDamage, target, "", id, float(num), 1);	
	}
	return 0;
}

public doOddech(id){
	if(!gSkill22[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][8]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	gUsed[id][8] = true;
	new iOrigin[3];
	get_user_origin(id, iOrigin, 3);
	
	new Float:fEOrigin[3];
	IVecFVec(iOrigin, fEOrigin);
	
	new Float:fOrigin[3];
	pev(id, pev_origin, fOrigin);
	
	new Float:fDistance;
	xs_vec_sub(fEOrigin, fOrigin, fEOrigin);
	fDistance = vector_length(fEOrigin);
	if(fDistance > 250.0)
	xs_vec_mul_scalar(fEOrigin, 250.0/fDistance, fEOrigin);
	
	new Float:fWysokoscWalca  = vector_length(fEOrigin); 
	
	new args[6];
	args[0] = floatround(fOrigin[0]);
	args[1] = floatround(fOrigin[1]);
	args[2] = floatround(fOrigin[2]);
	args[3] = floatround(fEOrigin[0]);
	args[4] = floatround(fEOrigin[1]);
	args[5] = floatround(fEOrigin[2]);
	
	xs_vec_normalize(fEOrigin, fEOrigin);
	
	burn_damage(id, 90.0, fWysokoscWalca, fOrigin);
	set_task(0.1, "task_spray", 0, args, 6, "a", 3);
	emit_sound(id, CHAN_STATIC, gOddechSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
	return 1;
}

#define TASK_STOP 666

burn_damage(id,Float:radius,Float:wys,Float:fOrigin[3]) {	
	new Float:fOrigin2[3],Float:fDistance;
	for(new i=1; i<=33;i++){
		if(!is_user_alive(i) || get_user_team(i) == get_user_team(id)) continue;
		if(i == id) continue;
		
		pev(i, pev_origin, fOrigin2);
		xs_vec_sub(fOrigin2, fOrigin, fOrigin2);
		
		fDistance = vector_length(fOrigin2);
		
		if(floatsqroot(floatpower(wys,2.0) + floatpower(radius, 2.0)) >= fDistance){
			gStop[i] = true;
			setGlowShell(i, 10.0, 0, 128, 255)
			set_task(float(gSkill22[id]), "gStopFalse", i+TASK_STOP);
		}
	}
}

setGlowShell(id, Float:width, red=0, green=0, blue=0){
	if(is_user_alive(id)){
		new Float:color[3];
		color[0] = float(red);
		color[1] = float(green);
		color[2] = float(blue);
		set_pev(id, pev_rendermode, kRenderNormal);
		set_pev(id, pev_renderfx, (width)?kRenderFxGlowShell:kRenderFxNone);
		set_pev(id, pev_rendercolor, color);
		set_pev(id, pev_renderamt, width);
	}
}

public gStopFalse(id){
	id -= TASK_STOP;
	setGlowShell(id, 0.0);
	gStop[id] = false;
	engfunc(EngFunc_SetClientMaxspeed, id, 255.0);
}

public task_spray(args[]) {
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(120) // TE_SPRAY - Throws a shower of sprites or models
	write_coord(args[0]) // start pos
	write_coord(args[1])
	write_coord(args[2])
	write_coord(args[3]) // velocity
	write_coord(args[4])
	write_coord(args[5])
	write_short(sprite_freez) // spr
	write_byte(15) // count
	write_byte(2) // speed
	write_byte(100) //(noise)
	write_byte(5) // (rendermode)
	message_end()
	return PLUGIN_CONTINUE;
}

public doBlind(id){
	if(!gSkill20[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][6]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(gLevel[id] > 25){
		ColorChat(id, GREEN, "%s^x01 Masz za wysoki level, aby tego uzyc!", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][6] = true;
		makeScreenFade(target, float(gSkill20[id]), float(gSkill20[id]) + 0.3, 0, 0, 0, 255);
		emit_sound(target, CHAN_STATIC, gBlindSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
		
		set_hudmessage(127, 255, 85, 0.01, 0.15, 0, 4.1, 4.2, 2.1, 1.1, 3);
		show_hudmessage(id, "[XP] Oslepiles przeciwnika na %d sekund%s!", gSkill20[id], gSkill20[id] == 1 ? "e" : "y");	
	}
	return 0;
}

public WyswietlBRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na bariere ktora odbije %% zadanych Tobie obrazen\w^nWymagany poziom:\y 5\w^nAktualna szansa - [\y%d%%\w]^nAktualnie odbije - [\y%d%%\w]^nSzansa po dodaniu punktu - [\y%d%% Obr\w]^nPo dodaniu punktu odbije - [\y%d%% Obr\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill13[id] * 3, gSkill13[id] * 10, (gSkill13[id] + 1) * 3, (gSkill13[id] + 1) * 10, gSkill13[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "BRMenu");
}

public handleBRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill13[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(^x045^x01 wymagany)", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill13[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Lustrzana Bariera wynosi teraz^x03 %d %%^x01 i odbija^x03 %d %% obrazen", gPrefix, gSkill13[id] * 3, gSkill13[id] * 10);
				WyswietlBRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlOBMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Gumowe Buty redukuja Twoje obrazenia po upadku\w^nAktualnie redukuja - [\y%d%%\w]^nPo dodaniu punktu beda redukowac - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill14[id] * 5, (gSkill14[id] + 1) * 5, gSkill14[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OBMenu");
}

public handleOBMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill14[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill14[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Gumowe Buty redukuja teraz^x03 %d %%^x01 obrazen po upadku", gPrefix, gSkill14[id] * 5);
				WyswietlOBMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlGRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na wylosowanie Pingwina. Nie zadaje obrazen ale odpycha!\w^nWymagany poziom:\y 25\w^nAktualna szansa - [\y%d%%\w]^nSzansa po dodaniu punktu - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill12[id] * 5, (gSkill12[id] + 1) * 5, gSkill12[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "GRMenu");
}

public handleGRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill12[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			if(gLevel[id] < 25){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(^x045^x01 wymagany)", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlGRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill12[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Latajacego Pingwina wynosi teraz^x03 %d %%", gPrefix, gSkill12[id] * 5);
				WyswietlGRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlXPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Co 5 dodanych punktow zyskujesz dodatkowy 1XP za zabicie\w^nWymagany poziom:\y 5\w^nAktualnie - [Dodatkow%s\y %dXP\w]^nPo dodaniu 5 punktow - [Dodatkow%s\y %dXP\w]^nPunkty umiejetnosci: \y%d\r /\y 20\w", gPoint[id], gSkill11[id] >= 5 ? "y" : "e", gSkill11[id] / 5, gSkill11[id] >= 5 ? "y" : "e", (gSkill11[id] + 5) / 5, gSkill11[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "XPMenu");
}

public handleXPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill11[id] >= 20){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(5 wymagany)", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill11[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Dodatkowy Exp jest teraz na poziomie^x03 %d", gPrefix, gSkill11[id]);
				WyswietlXPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlKMMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Po uzyciu wygladasz jak przeciwnik\w^nWymagany poziom :\y 2\w^nAktualnie - [Przez\y %d sekund\w]^nPo dodaniu punktu - [Przez\y %d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 4\w", gPoint[id], gSkill7[id] * 5, (gSkill7[id] + 1) * 5, gSkill7[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KMMenu");
}

public handleKMMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill7[id] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gLevel[id] < 2){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(2 wymagany)", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill7[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Kamuflaz trwa teraz^x03 %d sekund", gPrefix, gSkill7[id] * 5);
				WyswietlKMMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlSTMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Po uzyciu stajesz sie niewidzialny\w^nWymagany poziom:\y %d\w^nAktualnie - [\y%d sekund\w]^nPo dodaniu punktu - [\y%d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gStealth[gSkill6[id]], gSkill6[id] * 2, (gSkill6[id] + 1) * 2, gSkill6[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "STMenu");
}

public handleSTMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill6[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gLevel[id] < gStealth[gSkill6[id]]){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom!(%d wymagany)", gPrefix, gStealth[gSkill6[id]]);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill6[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja Niewidzialnosc trwa teraz^x03 %d sekund", gPrefix, gSkill6[id] * 2);
				WyswietlSTMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlRSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na Odrodzenie po smierci\w^nWymagany poziom:\y 5\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill3[id] * 2, (gSkill3[id] + 1) * 2, gSkill3[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "RSMenu");
}

public handleRSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill3[id] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill3[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Odrodzenie wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill3[id] - 1) * 2, gSkill3[id] * 2);
				WyswietlRSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlPHMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Gdy uzyjesz tej umiejetnosci przeciwnicy w zasiegu zostana odepchnieci\w^nWymagany poziom:\y 40\w^n", gPoint[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "Aktualny zasieg dzialania - [\y%d untiow\w]^nAktualna sila odepchniecia - [\y%d unitow\w]^nZasieg dzialania po dodaniu punktu - [\y%d untiow\w]^nSila odepchniecia po dodaniu punktu - [\y%d unitow\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", 20 * gSkill10[id], 40 * gSkill10[id], 20 * (gSkill10[id] + 1), 40 * (gSkill10[id] + 1), gSkill10[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PHMenu");
}

public handlePHMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill10[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gLevel[id] < 40){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (40 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill10[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz twoje Odepchniecie zadziala z zasiegu^x03 %d unitow^x01 oraz odrzuci z sila^x03 %d unitow", gPrefix, 40 * gSkill10[id], 20 * gSkill10[id]);
				WyswietlPHMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlSGMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Redukuje obrazenia gdy ktos stoi Ci na glowie\w^nStandardowo tracisz - [\y%dHP\w]^nAktuaie tracisz - [\y%dHP\w]^nPo dodaniu punktu bedziesz tracic - [\y%dHP\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], floatround(DAMAGE), floatround(DAMAGE - (gSkill9[id] * 7)), floatround(DAMAGE - ((gSkill9[id] + 1) * 7)), gSkill9[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SGMenu");
}

public handleSGMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill9[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill9[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz twoja Stalowa Glowa obniza obrazenia o^x03 %dHP", gPrefix, floatround(DAMAGE - ((gSkill9[id] - 1) * 7)));
				WyswietlSGMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlZSMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie zestawu bronin\w^nWymagany poziom:\y 25\w^nUwaga -\y Aby to wykupic musisz posiadac karabiny na maks. poziomie!\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill18[id] * 5, (gSkill18[id] + 1) * 5, gSkill18[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ZSMenu");
}

public handleZSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill15[id] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Karabiny aby to ulepszyc!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gSkill18[id] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gLevel[id] < 25){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (25 wymagany)", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill18[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Zestaw wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill18[id] - 1) * 5, gSkill18[id] * 5);
				WyswietlZSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlMGMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie losowego karabinu^n\wWymagany poziom:\y 15\w^nUwaga -\y Aby to wykupic musisz posiadac pistolety na maks. poziomie!\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill15[id] * 5, (gSkill15[id] + 1) * 5, gSkill15[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MGMenu");
}

public handleMGMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill8[id] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Pistoletow aby to ulepszyc!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gSkill15[id] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill15[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Karabin wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill15[id] - 1) * 5, gSkill15[id] * 5);
				WyswietlMGMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlOMMenu(id){
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Wypuszczajac chmure mrozu zamraszamy wszystkich, ktorzy w niej sa^n\wWymagany poziom:\y 45^n\wAktualnie zamraza na [\y%d sekund\w]^nPo dodaniu punktu bedzie zamrazac na - [\y%d sekund\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill22[id], gSkill22[id]+1, gSkill22[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OMMenu");
}

public handleOMMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill22[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOMMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOMMenu(id);
				return 1;
			}
			if(gLevel[id] < 45){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (45 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill22[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Oddech Mrozu zostal ulepszony do^x03 %d poziomu zamraza na %d sekund", gPrefix, gSkill22[id], gSkill22[id]);
				WyswietlOMMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}


public WyswietlSS2Menu(id){
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Klikajac [e] + [prawy myszy] wybija nas do przodu^n\wWymagany poziom :\y 15^n\wPunkty umiejetnosci: \y%d\r /\y 15\w", gPoint[id], gSkill21[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SS2Menu");
}

public handleSS2Menu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill21[id] >= 15){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSS2Menu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSS2Menu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill21[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Super Skok zostal wzmociony do^x03 %d poziomu", gPrefix, gSkill21[id]);
				WyswietlSS2Menu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlWZMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Kazdy punkt dodany w wzmocnienie wzmacnia Twoje inne umiejetnosci\w^nWymagany poziom:\y 3\w^nAktualnie wzmacnia - [\y%d%%\w]^nPo dodaniu punktu bedzie wzmacniac - [\y%d%%\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill19[id] * 4, (gSkill19[id] + 1) * 4, gSkill19[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "WZMenu");
}

public handleWZMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill19[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gLevel[id] < 3){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (3 wymagany)", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill19[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje wzmocnienie zostalo ulepszone na^x03 %d poziom", gPrefix, gSkill19[id]);
				WyswietlWZMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlOSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz oslepic nakierowanego przeciwnika\w^nDziala do poziomu:\y 25\w^nAktualnie oslepia na - [\y%ds\w]^nPo dodaniu punktu bedzie oslepiac na - [\y%ds\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill20[id], gSkill20[id] + 1, gSkill20[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OSMenu");
}

public handleOSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill20[id] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			if(gLevel[id] > 25){
				ColorChat(id, GREEN, "%s^x01 Masz za wysoki poziom, skill mozna posiadac tylko do 25 levela!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill20[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Oslepienie dziala teraz na^x03 %d sekund%s", gPrefix, gSkill20[id], gSkill20[id] == 1 ? "e" : "y");
				WyswietlOSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlKSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Twoj noz zadaje dodatkowe obrazenia\w^nWymagany poziom:\y 10\w^nAktualne dodatkowe obrazenia - [\y%d\w]^nDodatkowe obrazenia po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r /\y 10\w", gPoint[id], gSkill16[id] * 2, (gSkill16[id] + 1) * 2, gSkill16[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KSMenu");
}

public handleKSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill16[id] >= 10){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gLevel[id] < 10){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (10 wymagany)", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill16[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Dodatkowe Obrazenia z noza wynosza teraz^x03 %d", gPrefix, gSkill16[id] * 2);
				WyswietlKSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlPSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Masz szanse na dostanie losowego pistoletu\w^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^nPunkty umiejetnosci: \y%d\r /\y 3\w", gPoint[id], gSkill8[id] * 5, (gSkill8[id] + 1) * 5, gSkill8[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PSMenu");
}

public handlePSMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill8[id] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill8[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Pistolet wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill8[id] - 1) * 5, gSkill8[id] * 5);
				WyswietlPSMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill2Menu(id);
	}
	
	return 1;
}

public WyswietlARMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz postawic aure zycia ktora bedzie leczycw^nAktualnie - [Leczy\y %dHP\r/\ysek\w przez\y %d sek\w]^nPo dodaniu punktu - [Bedzie leczyc\y %dHP\r/\ysek\w przez\y %d sek\w]^nPunkty umiejetnosci:\y %d\r /\y 4", gPoint[id], gSkill5[id] * 5 + gSkill19[id], gSkill5[id] * 5 + gSkill19[id], (gSkill5[id] + 1) * 5 + gSkill19[id], (gSkill5[id] + 1) * 5 + gSkill19[id], gSkill5[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ARMenu");
}

public handleARMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill5[id] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill5[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja aura zycia zostala ulepszona! Trwa teraz^x03 %d sekund^x01 oraz leczy^x03 %d HP^x01 na sekunde", gPrefix, gSkill5[id] * 5 + gSkill19[id], gSkill5[id] * 5 + gSkill19[id]);
				WyswietlARMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlPRMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Mozesz zeslac blyskawice na przeciwnika ktory go zrani\w^nWymagany poziom:\y 18\w^nWykupione - [%s\w]^nAktualnie zabiera - [\y%d%% Aktualnego HP\w]^nPo dodaniu zabierze - [\y%d%% Aktualnego HP\w]^nPunkty umiejetnosci: \y%d\r /\y 5\w", gPoint[id], gSkill4[id] ? "\yTak" : "\rNie", gSkill4[id] * 10, (gSkill4[id] + 1) * 10, gSkill4[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PRMenu");
}

public handlePRMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill4[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gLevel[id] < 18){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (18 wymagany)", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill4[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje obrazenia Blyskawica wzrosly z^x03 %d%%^x01 do^x03 %d%%^x01 obrazen aktualnego hp", gPrefix, (gSkill4[id] - 1) * 10, gSkill4[id] * 10);
				WyswietlPRMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkill3Menu(id);
	}
	
	return 1;
}

public WyswietlHPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Zwieksza Twoje maksymalne zycie\w^nAktualne zycie - [\y%d\w]^nZycie po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r/\y 5\w", gPoint[id], 100 + (gSkill0[id] * 10), 100 + (gSkill0[id] + 1) * 10, gSkill0[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "HPMenu");
}

public handleHPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill0[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill0[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje Zycie wzroslo z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill0[id] - 1, gSkill0[id]);
				WyswietlHPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}

public WyswietlAPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[4Fragers.com]\y ExpMod\w^n^nPunkty: \r%i\w^nOpis umiejetnosci:\y Zwieksza twoj maksymalny pancerz\w^nAktualny pancerz - [\y%d\w]^nPancerz po dodaniu punktu - [\y%d\w]^nPunkty umiejetnosci: \y%d\r/\y 5\w", gPoint[id], gSkill1[id] * 20, (gSkill1[id] + 1) * 20, gSkill1[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "APMenu");
}

public handleAPMenu(id, key){
	switch(key + 1){
	case 1:{
			if(gSkill1[id] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill1[id] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj Armor wzrosl z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill1[id] - 1, gSkill1[id]);
				WyswietlAPMenu(id);
				return 1;
			}
		}
	case 10: WyswietlSkillMenu(id);
	}
	
	return 1;
}
/*KONIEC MEN*/
/*STOCKI ORAZ ODPOWIEDNIKI DO KOMEND*/
public smashHead(pwned, pwnzor, Float:damage){
	if(get_user_team(pwnzor) != get_user_team(pwned)){
		static Float:fOrigin[3], Float:Health;
		pev(pwned, pev_origin, fOrigin);	
		pev(pwned, pev_health,  Health);
		
		if(Health < damage){
			engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0);
			write_byte(TE_PARTICLEBURST);
			engfunc(EngFunc_WriteCoord, fOrigin[0]);
			engfunc(EngFunc_WriteCoord, fOrigin[1]);
			engfunc(EngFunc_WriteCoord, fOrigin[2]);
			write_short(50);
			write_byte(72);
			write_byte(10);
			message_end();
		}
		
		engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fOrigin, 0);
		write_byte(TE_BLOODSPRITE);
		engfunc(EngFunc_WriteCoord, fOrigin[0] +  8.0);
		engfunc(EngFunc_WriteCoord, fOrigin[1]);
		engfunc(EngFunc_WriteCoord, fOrigin[2] + 26.0);
		write_short(sprite_bloodspray);
		write_short(sprite_blood);
		write_byte(248);
		write_byte(4);
		message_end();
		
		ExecuteHam(Ham_TakeDamage, pwned, "", pwnzor, damage, 1);
	}
}

public writeHud(id){
	for (new id=0; id < 32; id++){
		if(is_user_connected(id) && is_user_alive(id)){
			new szText[150];
			
			if(gLevel[id] >= 65) 	format(szText, sizeof szText - 1,"Poziom: %d/65 | Exp: %d", gLevel[id], gXp[id]);
			else 			format(szText, sizeof szText - 1, "Poziom: %d/65 | Exp: %d/%d (+%i)", gLevel[id], gXp[id], gTable[gLevel[id]], gTable[gLevel[id]]-gXp[id]);
			
			
			message_begin(MSG_ONE, gStatusMsg, {0,0,0}, id);
			write_byte(0);
			write_string(szText);
			message_end();
		}
	}
}

public doReset(id){
	if(is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc nie zywy aby zrestartowac punkty", gPrefix);
		return 1;
	}
	
	gSkill0[id]  = 0;
	gSkill1[id]  = 0;
	gSkill2[id]  = 0;
	gSkill3[id]  = 0;
	gSkill4[id]  = 0;
	gSkill5[id]  = 0;
	gSkill6[id]  = 0;
	gSkill7[id]  = 0;
	gSkill8[id]  = 0;
	gSkill9[id]  = 0;
	gSkill10[id] = 0;
	gSkill11[id] = 0;
	gSkill12[id] = 0;
	gSkill13[id] = 0;
	gSkill14[id] = 0;
	gSkill15[id] = 0;
	gSkill16[id] = 0;
	gSkill17[id] = 0;
	gSkill18[id] = 0;
	gSkill19[id] = 0;
	gSkill20[id] = 0;
	gSkill21[id] = 0;
	gSkill22[id] = 0;
	gPoint[id]   = gLevel[id];
	gPoint[id]   += (gLevel[id]/10);
	
	ColorChat(id, GREEN, "%s^x01 Zresetowales statystyki, posiadasz [%d] wolnych punktow!", gPrefix, gPoint[id]);
	
	return 1;
}

public openMenu(id){
	WyswietlMainMenu(id);
	return 1;
}

public respawn_player(id){
	if(!gSkill3[id]) return;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill3[id] * 2){
		set_task(1.0, "respawnPlayer", id);
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Udalo Ci sie odrodzic!", gPrefix);
	}
}

public tryPingwin(id){
	id -= TASK_PING;
	
	if(!gSkill12[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= (gSkill12[id] * 7)){		
		gHasSuperGrenade[id] = true;
		
		give_item(id, "weapon_hegrenade");
		
		set_task(0.2, "eventCurWeapon", id);
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales^x03 Latajacego Pingwina^x01!", gPrefix);
	}
	
	return 0;
}

public tryKar(id){
	id -= TASK_KAR;
	if(!gSkill15[id]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill15[id] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_awp");
				cs_set_user_bpammo(id, CSW_AWP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_awp", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Karabin!", gPrefix);
	}
	return 0;
}

public tryZes(id){
	id -= TASK_KAR;
	if(!gSkill18[id]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill18[id] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_deagle");
				fm_give_item(id, "weapon_m4a1");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_user_bpammo(id, CSW_M4A1, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_m4a1", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_usp");
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_p228");
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_elite");
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Zestaw Broni!", gPrefix);
	}
	return 0;
}

public tryGun(id){
	id -= TASK_GUN;
	if(!gSkill8[id]) return 1;
	if(!is_user_alive(id) || bWeapon[id]) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill8[id] * 5){
		new random_weapon = random_num(1, 5);
		switch(random_weapon){
		case 1:{
				fm_give_item(id, "weapon_deagle");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
			}
		case 2:{
				fm_give_item(id, "weapon_glock18");
				cs_set_user_bpammo(id, CSW_GLOCK18, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_glock18", id ), 1);
			}
		case 3:{
				fm_give_item(id, "weapon_p228");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
			}
		case 4:{
				fm_give_item(id, "weapon_usp");
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
			}
		case 5:{
				fm_give_item(id, "weapon_elite");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
			}
		}
		bWeapon[id] = true;
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales Pistolet%s!", gPrefix, random_weapon == 5 ? "y" : "");
	}
	return 0;
}

public doAura(id){
	if(!gSkill5[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][1]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:mins[3], Float:maxs[3];
	
	mins = Float:{-64.0, -64.0, -64.0};
	maxs = Float:{64.0, 64.0, 64.0};
	
	pev(id, pev_origin, gfOrigin);
	
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target"));
	
	engfunc(EngFunc_SetModel, ent, gAuraModel) ;
	engfunc(EngFunc_SetSize, ent, mins, maxs);
	engfunc(EngFunc_SetOrigin, ent, gfOrigin);
	set_pev(ent, pev_solid, SOLID_TRIGGER);
	set_pev(ent, pev_movetype, MOVETYPE_NONE);
	set_pev(ent, pev_classname, gAuraClassname);
	set_pev(ent, pev_owner, id);
	
	switch(get_user_team(id)){
	case 1: set_rendering(ent, kRenderFxGlowShell, 255, 0, 0, kRenderTransAlpha, 35);
	case 2: set_rendering(ent, kRenderFxGlowShell, 0, 32, 255, kRenderTransAlpha, 35);
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	set_task(float(gSkill5[id] * 5 + gSkill19[id]), "taskAuraRemove", ent);
	
	ColorChat(id, GREEN, "%s^x01 Postawiles Aure [^x03%dHP / sekunde^x01 stac bedzie:^x03 %d sekund^x01]", gPrefix, gSkill5[id] * 5 + gSkill19[id], gSkill5[id] * 5 + gSkill19[id]);
	gUsed[id][1] = true;
	return 0;
} 

fm_cs_get_grenade_type_myid(index){
	if(get_pdata_int(index, 96) & (1<<8)){
		return 3;
	}	
	
	return get_pdata_int(index, 114) & 3;
}

public taskAuraRemove(ent){
	if(pev_valid(ent)){
		engfunc(EngFunc_RemoveEntity, ent);
	}
}

public FW_FM_AuraThink(ent)
{
	if(!pev_valid(ent))
	return 0;
	
	static iPlayers[32], iNum;
	get_players(iPlayers, iNum, "a");
	static i;
	new owner = pev(ent, pev_owner);
	
	for(i = 0 ; i < iNum; i++)
	{
		new Float: Health
		pev(iPlayers[i], pev_health, Health);
		if(entity_range(iPlayers[i], ent) <= 100.0 && get_user_team(owner) == get_user_team(iPlayers[i])){
			if(Health >= (100 + (gSkill0[iPlayers[i]] * 10)))
			continue;
			else{
				set_pev(iPlayers[i], pev_health, (Health + gSkill5[owner] * 5.0 + gSkill19[owner]) >= float((100 + (gSkill0[iPlayers[i]] * 10))) ? float((100 + (gSkill0[iPlayers[i]] * 10))): (Health + gSkill5[owner] * 5.0 + gSkill19[owner]));
				message_begin(MSG_ONE, gScreenFadeMsg, {0,0,0}, iPlayers[i]);
				write_short((1<<12));
				write_short((1<<8));
				write_short(0x0000);
				write_byte(255);
				write_byte(0);
				write_byte(64);
				write_byte(64);
				message_end();
			}
		}
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	return 0;
}

public doStealth(id){
	if(!gSkill6[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][2]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	if(bUsed[id]){
		ColorChat(id, GREEN, "%s^x01 Nie mozesz teraz tego uzyc", gPrefix);
		return 1;
	}
	
	bUsed[id] = true;
	
	if(task_exists(id + TASK_STEALTH)) remove_task(id + TASK_STEALTH);
	
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 0);
	
	gfTime[id][0] = float((2 * gSkill6[id]));
	set_task(0.1, "Stealth_Countdown", id + TASK_STEALTH, "", _, "a", (gSkill6[id] * 2) * 10);
	
	emit_sound(id, CHAN_STATIC, gStealthSound, 1.0, ATTN_NORM, 0, PITCH_NORM );
	set_bartime(id,floatround(gfTime[id][0]),0);
	gUsed[id][2] = true;
	
	return 0;
}

public Stealth_Countdown(id){
	id -= TASK_STEALTH;
	
	if(gfTime[id][0] <= 0.3){
		set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 255);
		bUsed[id] = false;
	}
	
	gfTime[id][0] -= 0.1;
}

public doKamuflaz(id){
	if(!gSkill7[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][3]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	if(bUsed[id]){
		ColorChat(id, GREEN, "%s^x01 Nie mozesz teraz tego uzyc", gPrefix);
		return 1;
	}
	
	bUsed[id] = true;
	gfTime[id][1] = float(((5 * gSkill7[id]) + gSkill19[id]));
	set_task(0.1, "Kamuflaz_Countdown", id + TASK_KAMUFLAZ, "", _, "a", ((gSkill7[id] * 5) + gSkill19[id]) * 10);
	
	switch(get_user_team(id)){
	case 1:	cs_set_user_model(id, "urban");
	case 2:	cs_set_user_model(id, "leet");
	}
	
	emit_sound(id, CHAN_STATIC, gCamouflageSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
	set_bartime(id,floatround(gfTime[id][1]),0);
	gUsed[id][3] = true;
	
	return 1;
}

public Kamuflaz_Countdown(id){
	id -= TASK_KAMUFLAZ;
	
	if(gfTime[id][1] <= 0.3){
		bUsed[id] = false;
		cs_reset_user_model(id);
	}
	
	gfTime[id][1] -= 0.1;
}

fm_add_user_armor(id, Float:amount, type){
	set_pev(id, pev_armorvalue, amount);
	set_pdata_int(id, 112, type);
	
	if (type){
		message_begin(MSG_ONE_UNRELIABLE , gArmorMsg , _ , id);
		write_byte(type == 2 ? 1 : 0);
		message_end();
	}
} 

public respawnPlayer(id){
	ExecuteHamB(Ham_CS_RoundRespawn, id);
	
	if (is_user_bot(id) && pev(id, pev_deadflag) == DEAD_RESPAWNABLE){
		dllfunc(DLLFunc_Spawn, id);
	}
	
	set_bartime(id, 10, 0);
	set_task(10.0, "godmode_off", id+6666);
	set_user_godmode(id, 1);
	setGlowShell(id, 10.0, 255, 255, 255);
	
	new name[32];
	get_user_name(id,name,31);
	
	set_hudmessage(127, 255, 85, -1.0, 0.15, 1, 0.0, 5.0, 0.1, 0.2, 3);
	show_hudmessage(0, "Gracz ^"%s^" odrodzil sie!", name);
}

Thunder(start[3], end[3]){			
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ); 
	write_byte(TE_BEAMPOINTS); 
	write_coord(start[0]); 
	write_coord(start[1]); 
	write_coord(start[2]); 
	write_coord(end[0]); 
	write_coord(end[1]); 
	write_coord(end[2]); 
	write_short(sprite_lightning); 
	write_byte(1);
	write_byte(5);
	write_byte(7);
	write_byte(20);
	write_byte(30);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	message_end();
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, end);
	write_byte(TE_SPARKS);
	write_coord(end[0]);
	write_coord(end[1]);
	write_coord(end[2]);
	message_end();
	
	emit_sound(0 ,CHAN_ITEM, gThunderSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
}

makeScreenFade(id, Float:fDuration, Float:fHoldtime, red, green, blue, alpha)
{
	message_begin(MSG_ONE, gScreenFadeMsg, {0, 0, 0}, id);
	write_short(floatround(4096.0 * fDuration, floatround_round));
	write_short(floatround(4096.0 * fHoldtime, floatround_round));
	write_short(4096);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(alpha);
	message_end();

	return 1;
}

Smoke(iorigin[3], scale, framerate){
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_SMOKE);
	write_coord(iorigin[0]);
	write_coord(iorigin[1]);
	write_coord(iorigin[2]);
	write_short(sprite_smoke);
	write_byte(scale);
	write_byte(framerate);
	message_end();
}

stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] ){
	new Float:fEntOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, fEntOrigin);

	new Float:fDistance[3];
	fDistance[0] = fEntOrigin[0] - fOrigin[0];
	fDistance[1] = fEntOrigin[1] - fOrigin[1];
	fDistance[2] = fEntOrigin[2] - fOrigin[2];

	new Float:fTime = ( vector_distance( fEntOrigin,fOrigin) / fSpeed);

	fVelocity[0] = fDistance[0] / fTime;
	fVelocity[1] = fDistance[1] / fTime;
	fVelocity[2] = fDistance[2] / fTime;

	return (fVelocity[0] && fVelocity[1] && fVelocity[2]);
}

stock set_velocity_from_origin(ent, Float:fOrigin[3], Float:fSpeed){
	new Float:fVelocity[3];
	get_velocity_from_origin(ent, fOrigin, fSpeed, fVelocity);

	entity_set_vector(ent, EV_VEC_velocity, fVelocity);

	return (1);
}

public doPush(id){
	if(!gSkill10[id]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][4]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	if(get_user_team(id) == 2){
		ColorChat(id, GREEN, "%s^x01 Tylko^x04 TT^x01 moze uzycwac tego skilla!", gPrefix);
		return 1;
	}

	static iPlayers[32], iNum, i;
	get_players(iPlayers, iNum, "a");

	for(i = 0 ; i < iNum; i++)
	{	
		new vOrigin2[3];
		get_user_origin(id, vOrigin2);
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
		write_byte(21);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2]);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2] + (gSkill10[id] * 50));
		write_short(sprite_push);
		write_byte(0);
		write_byte(0);
		write_byte(5);
		write_byte(64);
		write_byte(0);
		write_byte(128);
		write_byte(128);
		write_byte(135);
		write_byte(128);
		write_byte(0);
		message_end();
		
		emit_sound(id ,CHAN_ITEM, gPushSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
		
		if(entity_range(iPlayers[i], id) <= float(gSkill10[id] * 40) && get_user_team(id) != get_user_team(iPlayers[i])){
			new Float:fOrigin[2][3], vOrigin[3], b, flags;
			entity_get_vector(iPlayers[i], EV_VEC_origin, fOrigin[1]);
			entity_get_vector(id, EV_VEC_origin, fOrigin[0]);
			get_user_origin(iPlayers[i], vOrigin);
			flags = entity_get_int(iPlayers[i], EV_INT_flags);
			
			for(b = 0;b <= 2 ; b ++) 
			{
				fOrigin[1][b] -= fOrigin[0][b];
				
				if(flags & FL_ONGROUND){
					fOrigin[1][b] *= (float(gSkill10[id]) * 4.0);
				}
				
				else{
					fOrigin[1][b] *= (float(gSkill10[id]) * 1.5);
				}
				
				entity_set_vector(iPlayers[i], EV_VEC_velocity, fOrigin[1]);
			}
		}
	}
	gUsed[id][4] = true;

	return 0;
}

public FW_FM_Setmodel(ent, model[]){
	new owner = pev(ent, pev_owner);
	if(gHasSuperGrenade[owner]){
		if(equali(model,"models/w_hegrenade.mdl")){
			engfunc(EngFunc_SetModel, ent, gPingwinModelW); 
			return FMRES_SUPERCEDE; 
		} 
	}
	return FMRES_IGNORED;
} 

public eventTouch(toucher, touched){
	new id = entity_get_edict(toucher, EV_ENT_owner); 

	if(fm_cs_get_grenade_type_myid(toucher) == He){
		if(gHasSuperGrenade[id]){
			set_task(1.5, "removePing", id + TASK_REMOVED, _, _, "a", 1);
		}
	}
}

public removePing(id){
	id -= TASK_REMOVED;
	gHasSuperGrenade[id] = false;
}

addExp(id, num){
	gXp[id] += num;
	refreshExp(id);
}

refreshExp(id){
	while(gLevel[id] <= 64 && gXp[id] >= gTable[gLevel[id]]){
		gLevel[id] += 1;
		gPoint[id] += 1;
		
		if(gLevel[id] % 10 == 0){
			gPoint[id] += 1;
			ColorChat(id, GREEN,"%s^x01 Gratulacje! Dostajesz ^x04+1^x01 punkt", gPrefix); 
		}
		
		new szName[32];
		get_user_name(id, szName, sizeof szName - 1);
		ColorChat(0, GREEN,"%s^x01 Gratulacje!^x04 %s^x01 osiagnal poziom^x03 %d", gPrefix, szName, gLevel[id]); 
		
		if(is_user_alive(id)){
			new p_origin[3];
			get_user_origin(id, p_origin, 0);
			
			set_sprite(p_origin, sprite_lvlup, 30);
		}
	}
}

public blockMoney(id){
	if(is_user_connected(id) && gPlayerMoney[id] != read_data(1)){
		cs_set_user_money(id,gPlayerMoney[id],0);
	}
}

public giveMoney(id, level, cid){
	if (!(get_user_flags(id) & ADMIN_IMMUNITY)){
		console_print(id,"[AMXX] Nie masz uprawnien..");
		return PLUGIN_HANDLED;
	}

	new targetarg[32];
	read_argv(1, targetarg, 31);
	new target = cmd_target(id, targetarg, 11);

	if(!target){
		return PLUGIN_HANDLED;
	}

	new name[32];
	get_user_name(target, name, 31);

	gPlayerMoney[target] += 10;
	cs_set_user_money(target,gPlayerMoney[target],1)
	console_print(id,"[ExpMod] Dales ^"%s^" 5$ (Obecnie posiada %i$)", name, gPlayerMoney[target]);

	return PLUGIN_CONTINUE;
}

public rules(id,lvl,cid){
	if(!(get_user_flags(id) & ADMIN_MENU)){
		console_print(id,"[AMXX] Nie masz uprawnien");
		return PLUGIN_HANDLED;
	}

	new user[32], message[128], uid;
	read_argv(1, user, 32);
	new jezyk[3];
	get_user_info(id, "lang", jezyk, 2);

	if(equal(jezyk, "pl")) format(message,127,"say /zasady");
	else format(message,127,"say /rules");

	uid = find_player("bh",user);

	if(uid == 0){
		console_print(id,"[AMXX] Podales nieporawny nick");
		return PLUGIN_HANDLED;
	}
	client_cmd(uid,"%s",message);
	return PLUGIN_CONTINUE;
}

public changeUserMoney(id,ile){
	gPlayerMoney[id] += ile;
	cs_set_user_money(id,gPlayerMoney[id],1);
}

public blockBoom(){
	if (get_msg_args() != 8)
	return 0;
	
	if (get_msg_arg_int(1) != 3 || get_msg_arg_int(6) != 25 || get_msg_arg_int(7) != 30 || get_msg_arg_int(8) != 0)
	return 0;
	
	gOrigin[0] = get_msg_arg_float(2);
	gOrigin[1] = get_msg_arg_float(3);
	gOrigin[2] = get_msg_arg_float(4);
	
	genericShock(gOrigin, 575.0, "weaponbox", 32, 3.0, OBJECT_GENERIC);
	genericShock(gOrigin, 575.0, "armoury_entity", 32, 3.0, OBJECT_ARMOURY);
	genericShock(gOrigin, 575.0, "grenade", 32, 3.0, OBJECT_GRENADE);
	genericShock(gOrigin, 575.0, "hostage_entity", 32, 3.0, OBJECT_GENERIC);
	
	return 0;
}

public set_sprite(p_origin[3], sprite, radius)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, p_origin);
	write_byte(TE_EXPLOSION);
	write_coord(p_origin[0]);
	write_coord(p_origin[1]);
	write_coord(p_origin[2]);
	write_short(sprite_lvlup);
	write_byte(radius);
	write_byte(30);
	write_byte(4);
	message_end();
}

set_bartime(id, czas, startprogress=0){
	message_begin((id)?MSG_ONE:MSG_ALL, get_user_msgid("BarTime2"), _, id)
	write_short(czas);
	write_short(startprogress);
	message_end();   
}

genericShock(Float:hitPointOrigin[3], Float:radius, classString[], maxEntsToFind, Float:power, OBJECTTYPE:objecttype) { // bool:isthisplayer, bool:isthisarmouryentity, bool:isthisgrenade/*, Float:pullup*/) {
	new entList[32];
	if (maxEntsToFind > 32)
	maxEntsToFind = 32;
	
	new entsFound = find_sphere_class(0, classString, radius, entList, maxEntsToFind, hitPointOrigin);
	
	new Float:entOrigin[3];
	new Float:velocity[3];
	new Float:cOrigin[3];
	
	for (new j = 0; j < entsFound; j++) {
		switch (objecttype){
		case OBJECT_PLAYER:{
				if (!is_user_alive(entList[j]))
				continue;
			}
		case OBJECT_GRENADE:{
				new l_model[16];
				entity_get_string(entList[j], EV_SZ_model, l_model, 15);
				if (equal(l_model, "models/w_c4.mdl"))
				continue;
			}
		}
		
		entity_get_vector(entList[j], EV_VEC_origin, entOrigin);
		
		new Float:distanceNadePl = vector_distance(entOrigin, hitPointOrigin);
		
		if(entity_get_int(entList[j], EV_INT_flags) & FL_ONGROUND && entOrigin[2] < hitPointOrigin[2])
		entOrigin[2] = hitPointOrigin[2] + distanceNadePl;
		
		entity_get_vector(entList[j], EV_VEC_velocity, velocity);
		
		cOrigin[0] = (entOrigin[0] - hitPointOrigin[0]) * radius / distanceNadePl + hitPointOrigin[0];
		cOrigin[1] = (entOrigin[1] - hitPointOrigin[1]) * radius / distanceNadePl + hitPointOrigin[1];
		cOrigin[2] = (entOrigin[2] - hitPointOrigin[2]) * radius / distanceNadePl + hitPointOrigin[2];
		
		velocity[0] += (cOrigin[0] - entOrigin[0]) * power;
		velocity[1] += (cOrigin[1] - entOrigin[1]) * power;
		velocity[2] += (cOrigin[2] - entOrigin[2]) * power;
		
		entity_set_vector(entList[j], EV_VEC_velocity, velocity);
	}
}

public SaveData(id)
{
	if ( load_error[ id ] )
	{
		new nickname[35];
		get_user_name(id, nickname, 34);
		log_amx("There was an error on loading so stats won't be saved for: %s", nickname);
		return 0;
	}
	new host[32], user[32], pass[32], dbname[32], table[32];
	get_cvar_string("expmod_sql_host", host, 31);
	get_cvar_string("expmod_sql_user", user, 31);
	get_cvar_string("expmod_sql_pass", pass, 31);
	get_cvar_string("expmod_sql_db", dbname, 31);
	get_cvar_string("expmod_sql_table", table, 31);
	
	tuple = SQL_MakeDbTuple(host, user, pass, dbname);
	
	if ( tuple ) db = SQL_Connect(tuple, errcode, error, 2047);
	
	if (db == Empty_Handle)
	{
		log_amx("Could not connect to database. Error #%i: %s", errcode, error);
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		return 0;
	}
	else
	{
		new authid[35];
		new where_statement[1024];
		get_user_authid(id, authid, 34);
		format(where_statement, 511, "`authid` = '%s'", authid);
		format(mkQuery, 2047, "UPDATE %s SET \
		gXp = '%d', \
		gLevel = '%d', \
		gPoint = '%d', \
		gMoney = '%d', \
		gS0 = '%d', \
		gS1 = '%d', \
		gS2 = '%d', \
		gS3 = '%d', \
		gS4 = '%d', \
		gS5 = '%d', \
		gS6 = '%d', \
		gS7 = '%d', \
		gS8 = '%d', \
		gS9 = '%d', \
		gS10 = '%d', \
		gS11 = '%d', \
		gS12 = '%d', \
		gS13 = '%d', \
		gS14 = '%d', \
		gS15 = '%d', \
		gS16 = '%d', \
		gS17 = '%d', \
		gS18 = '%d', \
		gS19 = '%d', \
		gS20 = '%d', \
		gS21 = '%d', \
		gS22 = '%d' \
		WHERE %s"
		,table, gXp[id],gLevel[id],gPoint[id],gPlayerMoney[id],gSkill0[id],gSkill1[id],gSkill2[id],gSkill3[id],gSkill4[id],gSkill5[id],gSkill6[id],gSkill7[id],gSkill8[id],gSkill9[id],gSkill10[id],gSkill11[id],gSkill12[id],gSkill13[id],gSkill14[id],gSkill15[id],gSkill16[id],gSkill17[id],gSkill18[id], gSkill19[id],gSkill20[id],gSkill21[id],gSkill22[id], where_statement);
		query = SQL_PrepareQuery(db, mkQuery);
		SQL_Execute(query);
		
		SQL_QueryError(query, error, 2047);
		if(error[0])
		{
			log_amx("Could not execute query ^"%s^" -- Error: %s",mkQuery,error);
			if ( db ) SQL_FreeHandle( db );
			if ( tuple ) SQL_FreeHandle( tuple );
			if ( query ) SQL_FreeHandle( query );
			return 0;
		}
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		if ( query ) SQL_FreeHandle( query );
	}
	return 0;
}

public LoadData(id)
{
	new host[32], user[32], pass[32], dbname[32], table[32];
	get_cvar_string("expmod_sql_host", host, 31);
	get_cvar_string("expmod_sql_user", user, 31);
	get_cvar_string("expmod_sql_pass", pass, 31);
	get_cvar_string("expmod_sql_db", dbname, 31);
	get_cvar_string("expmod_sql_table", table, 31);
	
	tuple = SQL_MakeDbTuple(host, user, pass, dbname);
	
	if(tuple) db = SQL_Connect(tuple, errcode, error, 2047);
	
	if (db == Empty_Handle)
	{
		new nickname[35];
		get_user_name(id, nickname, 34);
		
		log_amx( "Could not connect to database. Error #%i: %s", errcode, error );
		log_amx( "SCXPM: Loading player stats failed. failed load protection initialated for: %s", nickname);
		log_amx( "SCXPM: Start from level 0" );
		load_error[ id ] = true ;
		if ( db ) SQL_FreeHandle( db );
		if ( tuple ) SQL_FreeHandle( tuple );
		return 0;
	}
	else
	{
		new where_statement[512];
		new authid[35];
		
		get_user_authid(id, authid, 34);
		
		format(where_statement, 511, "`authid` = '%s'", authid);
		format(mkQuery, 2047, "SELECT `gXp`,`gLevel`,`gPoint`,`gMoney`,`gS0`,`gS1`,`gS2`,`gS3`,`gS4`,`gS5`,`gS6`,`gS7`,`gS8`,`gS9`,`gS10`,`gS11`,`gS12`,`gS13`,`gS14`,`gS15`,`gS16`,`gS17`,`gS18`,`gS19`,`gS20`,`gS21`,`gS22` FROM `%s` WHERE %s", table, where_statement);
		query = SQL_PrepareQuery(db, mkQuery);
		SQL_Execute(query);
		
		SQL_QueryError(query,error,2047);
		if(error[0])
		{
			log_amx( "Could not execute query ^"%s^" -- Error: %s", mkQuery, error );
			load_error[ id ] = true;
			if ( db ) SQL_FreeHandle( db );
			if ( tuple ) SQL_FreeHandle( tuple );
			if ( query ) SQL_FreeHandle( query );
			return 0;
		}
		else
		{
			if (SQL_NumResults ( query ) == 1)
			{
				gXp[id] = SQL_ReadResult(query, 0);
				gLevel[id] = SQL_ReadResult(query, 1);
				gPoint[id] = SQL_ReadResult(query, 2); 
				gPlayerMoney[id] = SQL_ReadResult(query, 3); 
				gSkill0[id] = SQL_ReadResult(query, 4); 
				gSkill1[id] = SQL_ReadResult(query, 5); 
				gSkill2[id] = SQL_ReadResult(query, 6); 
				gSkill3[id] = SQL_ReadResult(query, 7); 
				gSkill4[id] = SQL_ReadResult(query, 8); 
				gSkill5[id] = SQL_ReadResult(query, 9); 
				gSkill6[id] = SQL_ReadResult(query, 10); 
				gSkill7[id] = SQL_ReadResult(query, 11); 
				gSkill8[id] = SQL_ReadResult(query, 12); 
				gSkill9[id] = SQL_ReadResult(query, 13); 
				gSkill10[id] = SQL_ReadResult(query, 14); 
				gSkill11[id] = SQL_ReadResult(query, 15); 
				gSkill12[id] = SQL_ReadResult(query, 16); 
				gSkill13[id] = SQL_ReadResult(query, 17); 
				gSkill14[id] = SQL_ReadResult(query, 18); 
				gSkill15[id] = SQL_ReadResult(query, 19);
				gSkill16[id] = SQL_ReadResult(query, 20);
				gSkill17[id] = SQL_ReadResult(query, 21);
				gSkill18[id] = SQL_ReadResult(query, 22);
				gSkill19[id] = SQL_ReadResult(query, 23);
				gSkill20[id] = SQL_ReadResult(query, 24);
				gSkill21[id] = SQL_ReadResult(query, 25);
				gSkill22[id] = SQL_ReadResult(query, 26);
				blockMoney(id);
			}
			else if (SQL_NumResults ( query ) < 1)
			{
				get_user_authid(id, authid, 34);
				format(where_statement, 511, "`authid` = '%s'", authid);
				format(mkQuery, 2047, "INSERT INTO %s SET %s", table, where_statement);
				query = SQL_PrepareQuery(db, mkQuery);
				SQL_Execute(query);
				SQL_QueryError(query,error,2047);
				if(error[0])
				{
					log_amx("Could not execute query ^"%s^" -- Error: %s",mkQuery,error);
					load_error[ id ] = true;
					if ( db ) SQL_FreeHandle( db );
					if ( tuple ) SQL_FreeHandle( tuple );
					if ( query ) SQL_FreeHandle( query );
					return 0;
				}
				
				if ( db ) SQL_FreeHandle( db );
				if ( tuple ) SQL_FreeHandle( tuple );
				if ( query ) SQL_FreeHandle( query );
				
				LoadData( id );
				return 0;
			}
		}
	}
	if (db) SQL_FreeHandle( db );
	if (tuple) SQL_FreeHandle( tuple );
	return 0;
}

